#//old/include/explore.g
#//old/include/user.g
#amelon.g

extern
    optNumber(ushort n)void,
    printNumber(uint n; ushort digits)void,
    add(*uint p; uint v)void,
    tic()void,
    magicSpell()void,
    clericSpell()void,
    spellBook()void,
    learnSpell()void,
    use(OBJECT o)void,
    physHit(ATTACK a; uint strength)void,
    mHit1()void,
    clearBoard()void,
    makeMove(OBJECT o)bool;

bool FirstCondition;
ushort Col;

/*
 * main - first routine, called first when scenario is loaded.
 */

proc main(*Vector_t v; **byte where; *uint len)void:
    extern
	run(bool restore)void,
	stats()void,
	gridNorm(GRIDLINE line; GRIDCOL col; TERRITORY t; ushort group)bool,
	gridSpec(GRIDLINE line; GRIDCOL col; TERRITORY t; ushort group)bool,
	gridMoved()void,
	mazeMove(MAZELINE l; MAZECOL c)bool,
	mazeUp()void,
	mazeDown()void,
	mazeMoved()void,
	mazeSpec()void,
	mazeSpecDoor(MAZELINE line; MAZECOL col; bool isHor)bool,
	monsterCheck()void,
	killMonster()void,
	dropped(OBJECT o)bool;

    V := v;
    V*.Run := run;
    V*.Stats := stats;

    V*.Dropped := dropped;
    V*.Use := use;

    V*.MonsterCheck := monsterCheck;
    V*.KillMonster := killMonster;

    V*.GridNorm := gridNorm;
    V*.GridSpec := gridSpec;
    V*.GridMoved := gridMoved;

    V*.MazeMove := mazeMove;
    V*.MazeUp := mazeUp;
    V*.MazeDown := mazeDown;
    V*.MazeMoved := mazeMoved;
    V*.MazeSpec := mazeSpec;
    V*.MazeSpecDoor := mazeSpecDoor;

    where* := pretend(&MainLine, *byte);
    len* := pretend(&GoElevator, *byte) - pretend(&MainLine, *byte);
corp;

/*
 * initLocal - initialize all of the world's local variables.
 */

proc initLocal()void:
    extern
	calcHit()uint,
	calcStr()uint,
	calcCarry()uint;
    ushort i;
    ATTACK a;

    V*.hitPoints := calcHit();
    V*.health := V*.hitPoints;
    V*.strength := calcStr();
    V*.money := 100;
    V*.food := 100;
    V*.maxCarryWeight := calcCarry();

    SpellPoints := 0;
    MagicPoints := 0;
    ClericPoints := 0;

    BlessTime := 0;
    LuckTime := 0;
    ShieldTime := 0;
    StealthTime := 0;
    StrengthTime := 0;
    VigorTime := 0;

    ShieldLevel := 0;
    StealthLevel := 0;
    StrengthLevel := 0;
    VigorLevel := 0;

    ShieldMax := 0;
    StealthMax := 0;
    HarmMax := 0;
    CureMax := 0;
    StrengthMax := 0;
    VigorMax := 0;

    SpellKnown := false;
    Paralyzed := false;
    Doubled := false;
    LuckKnown := false;
    LocateKnown := false;
    StrengthKnown := false;
    VigorKnown := false;
    ParalyzeKnown := false;
    DoubleKnown := false;
    WeakenKnown := false;

    for a from A_PUNCTURE - 1 upto A_DISPELL - 1 do
	AttackMax[a] := 0;
	ProtectMax[a] := 0;
	ProtectLevel[a] := 0;
	ProtectTime[a] := 0;
    od;

    for i from 0 upto MAZECNT - 1 do
	MazeCnt[i] := 254;		/* multiple of 2 (see below) */
    od;

    clearBoard();

    RotatePosition := 0;
    LastLightDoor := 4;
    Tic := 0;
    Armour := 255;
    Shield := 255;
    HintCycle := 0;
    TalkCycle := 0;
    ElevatorLevel := 23;

    OwnHorse := false;
    OnHorse := false;
    OwnBoat := false;
    OnBoat := false;
    OnCarpet := false;
    DoorParity := true;
    InDark := false;
    LightsOn := false;
    SCOn := false;
    TROn := false;
    SeenPris := false;
    GotMoney := false;
    GotSword := false;
    MagicDisabled := false;
    ZontallahDead := false;
    StaffGone := false;

    V*.Place(3, true, 0, 55, 56);	/* Club in handy place */

    V*.Place(16, false, 45, 9, 8);	/* Enchanted Bow */
    V*.Place(17, false, 37, 0, 13);	/* Thor's Hammer */
    V*.Place(18, false, 36, 1, 1);	/* Ruby of Fire */
    V*.Place(19, false, 43, 0, 2);	/* Diamond of Ice */
    V*.Place(20, false, 39, 0, 1);	/* Sacred Signet */

    V*.Place(22, false, 6, 2, 1);	/* Book of Lore in Asaru dungeon */
    V*.Place(24, false, 34, 5, 5);	/* Brass key in Ika */
    V*.Place(25, false, 35, 5, 5);	/* Gold key in Oka */
    V*.Place(30, false, 0, 0, 7);	/* Saintly Cloak in Asaru Cathedral */
    V*.Place(31, false, 4, 2, 5);	/* Thermal Robe in Asaru cellar */
    V*.Place(32, false, 23, 5, 7);	/* Elevator key in bottom level */
    V*.Place(33, false, 16, 1, 1);	/* Eye medallion */
    V*.Place(34, false, 8, 5, 0);	/* Magic Carpet in Atlantis Temple */
    V*.Place(35, false, 1, 6, 2);	/* Map in Asaru Chapel */

    /* Lamp and Wands in 3-D maze: */

    V*.Place(36, false, 25, 2, 5);
    V*.Place(37, false, 32, 5, 2);
    V*.Place(38, false, 32, 7, 2);
    V*.Place(39, false, 31, 0, 0);
    V*.Place(40, false, 29, 7, 6);
    V*.Place(41, false, 30, 4, 7);
    V*.Place(42, false, 29, 2, 6);
    V*.Place(43, false, 28, 7, 0);
    V*.Place(44, false, 26, 2, 6);
corp;

/*
 * run - actually run the world.
 */

proc run(bool restore)void:
    extern
	goGrid(GRID g; GRIDLINE wT; GRIDCOL wL; GRIDLINE l; GRIDCOL c)bool,
	gridCommand(char ch)void,
	mazeCommand(char ch)void;

    /* these aren't saved/restored, so always initialize them */

    GoElevator := false;
    ForceAttack := false;
    ForcePic := false;
    GoBuilding := false;
    GoChurch := false;
    GoDock := false;

    if not restore then
	initLocal();
	pretend(goGrid(0, 56, 56, 60, 60), void);
	V*.SetNewCursor(19);
	V*.PText(29);
    fi;
    while not V*.gameOver do
	if V*.onGrid then
	    gridCommand(V*.ReadChar());
	else
	    mazeCommand(V*.ReadChar());
	fi;
    od;
corp;

/*
 * dropped - the player has dropped something.
 */

proc dropped(OBJECT o)bool:
    ushort str;

    if o = 15 and not V*.onGrid and V*.maze = 8 and
	    V*.mazeLine = 10 and V*.mazeCol = 6 then
	str := 0;
	for o from 16 upto 20 do
	    if not V*.IsCarrying(o) then
		str := 1;
	    fi;
	od;
	if str = 0 then
	    V*.PText(144);
	    V*.Drop(15);
	    DroppedSword := true;
	    false
	else
	    true
	fi
    elif o >= 16 and o <= 20 and not V*.onGrid and V*.maze = 8 and
	    V*.mazeLine >= 9 and V*.mazeLine <= 11 and
	    V*.mazeCol >= 2 and V*.mazeCol <= 4 then
	V*.Drop(o);
	makeMove(o)
    elif o = 21 and not V*.onGrid and V*.maze = 46 and
	    V*.mazeLine = 0 and V*.mazeCol = 0 then
	V*.PText(167);
	V*.Drop(21);
	StaffGone := true;
	false
    else
	if o = Shield or o = Armour then
	    if o = Shield then
		Shield := 255;
	    else
		Armour := 255;
	    fi;
	    str := V*.GetObject(o)*.ob_strength;
	    V*.protection[A_PUNCTURE-1] := V*.protection[A_PUNCTURE-1] - str;
	    V*.protection[A_SMASH - 1] := V*.protection[A_SMASH - 1] - str;
	    V*.protection[A_MISSILE - 1] := V*.protection[A_MISSILE - 1] - str;
	elif o = 30 and SCOn then
	    SCOn := false;
	    V*.protection[A_DISPELL - 1] := V*.protection[A_DISPELL - 1] - 30;
	elif o = 31 and TROn then
	    TROn := false;
	    V*.protection[A_HEAT - 1] := V*.protection[A_HEAT - 1] - 30;
	    V*.protection[A_CHILL - 1] := V*.protection[A_CHILL - 1] - 30;
	fi;
	true
    fi
corp;

/*
 * pAtt - the player is attacking.
 */

proc pAtt()void:

    if V*.armed then
	V*.Use(V*.weaponNumber);
    else
	if V*.underAttack then
	    physHit(A_SMASH, V*.strength / 10 + 10);
	    mHit1();
	else
	    V*.PText(10);
	fi;
    fi;
corp;

/*
 * gridCommand - trap commands in grid play.
 */

proc gridCommand(char ch)void:
    bool gotCarpet, canFly;

    gotCarpet := OnCarpet or V*.IsCarrying(34) or V*.IsHere(34);
    canFly := V*.gridTerritory = 0 or V*.gridTerritory = 16 or
	    V*.gridTerritory = 18 or V*.gridTerritory = 19 or
	    V*.gridTerritory >= 21 and V*.gridTerritory <= 23;
    if (ch = 'b' or ch = 'm' or ch = 'c') and not SpellKnown then
	ch := '\e';
    fi;
    if (ch = 'u' or ch = 'd') and not gotCarpet then
	ch := '\e';
    fi;
    case ch
    incase '8':
    incase '2':
    incase '4':
    incase '6':
    incase '5':
    incase '.':
    incase '\r':
    incase '\n':
    incase ' ':
	V*.GridStandard(ch);
	if ch ~= '.' and ch ~= '\r' and ch ~= '\n' and ch ~= ' ' then
	    tic();
	fi;
    incase '0':
	pAtt();
    incase 'b':
	spellBook();
    incase 'm':
	magicSpell();
    incase 'c':
	clericSpell();
    incase 'u':
    incase '+':
	V*.PText(
	    if OnCarpet then
		56
	    elif OnBoat then
		59
	    elif OnHorse then
		58
	    elif canFly then
		OnCarpet := true;
		V*.Drop(34);
		V*.Remove(34, true, V*.grid, V*.gridLine, V*.gridCol);
		V*.underAttack := false;
		V*.SetNewCursor(20);
		54
	    else
		61
	    fi);
    incase 'd':
    incase '-':
	V*.PText(
	    if OnCarpet then
		if canFly then
		    OnCarpet := false;
		    V*.PlaceHere(34);
		    V*.SetNewCursor(19);
		    55
		else
		    53
		fi
	    else
		57
	    fi);
    incase '?':
	V*.PText(
	    if SpellKnown then
		if gotCarpet then 45 else 44 fi
	    else
		if gotCarpet then 2 else 1 fi
	    fi);
    default:
	V*.PText(0);
    esac;
corp;

/*
 * pFind - money has been found.
 */

proc pFind(uint amount)void:

    add(&V*.money, amount);
    V*.PMess("You found ");
    V*.PNumber(amount);
    V*.Print(" G.P.");
corp;

/*
 * findMoney - see if he finds some money.
 */

proc findMoney()void:
    uint amount;

    if not V*.underAttack and
	    V*.Random(254) < MazeCnt[V*.maze] and
	    V*.Random(
		if V*.money < 100 then
		    5
		elif LuckTime = 0 then
		    20
		else
		    10
		fi) = 0 then
	MazeCnt[V*.maze] := MazeCnt[V*.maze] - 2;
	amount :=
	    case V*.maze
	    incase 0:
	    incase 1:
	    incase 3:
	    incase 9:
	    incase 13:
	    incase 25:
	    incase 26:
		25
	    incase 2:
	    incase 4:
	    incase 7:
	    incase 10:
	    incase 12:
	    incase 14:
	    incase 27:
	    incase 28:
		50
	    incase 5:
	    incase 11:
	    incase 15:
	    incase 29:
	    incase 30:
	    incase 38:
		75
	    incase 6:
	    incase 16:
	    incase 31:
	    incase 32:
	    incase 37:
		100
	    incase 17:
	    incase 34:
	    incase 35:
	    incase 36:
		200
	    incase 18:
	    incase 33:
	    incase 40:
	    incase 41:
		300
	    incase 19:
	    incase 43:
	    incase 45:
		400
	    incase 20:
	    incase 44:
		500
	    incase 21:
		600
	    incase 8:
	    incase 22:
		700
	    incase 23:
		800
	    incase 24:
	    incase 39:
	    incase 42:
	    incase 46:
		900
	    esac;
	if LuckTime = 0 then
	    amount := amount / 4;
	    amount := V*.Random(amount * 3) + amount;
	fi;
	V*.SetTopPalette(0);
	V*.PicDisp(
	    if amount >= 200 then
		18
	    elif amount >= 75 then
		20
	    else
		19
	    fi);
	pFind(amount);
    fi;
corp;

/*
 * mazeCommand - trap commands in maze play.
 */

proc mazeCommand(char ch)void:

    if (ch = 'b' or ch = 'm' or ch = 'c') and not SpellKnown then
	ch := '\e';
    fi;
    if V*.underAttack and V*.monsterNumber = 97 then
	/* fighting Zontallah!!!! */
	V*.monsterData.m_type := V*.Random(6) + A_PUNCTURE;
    fi;
    case ch
    incase '8':
    incase '4':
    incase '6':
    incase '5':
    incase '2':
    incase 'u':
    incase '+':
    incase 'd':
    incase '-':
    incase '.':
    incase '\r':
    incase '\n':
    incase ' ':
	V*.MazeStandard(ch);
	if ch = '8' and not V*.onGrid then
	    findMoney();
	fi;
	if ch ~= '.' and ch ~= '\r' and ch ~= '\n' and ch ~= ' ' then
	    tic();
	fi;
    incase '0':
	pAtt();
    incase 'b':
	spellBook();
    incase 'm':
	magicSpell();
    incase 'c':
	clericSpell();
    incase '?':
	V*.PText(if SpellKnown then 46 else 3 fi);
    default:
	V*.PText(0);
    esac;
corp;

/*
 * blocked - print out a message about being blocked.
 */

proc blocked()void:

    V*.PMess("The ");
    V*.PMess(V*.GetName(V*.monsterData.m_name));
    V*.Print(" blocks your way.\(BEL)");
corp;

/*
 * monsterCheck - check to see if an attack by a monster is O.K.
 */

proc monsterCheck()void:

    if not OnCarpet and not ForceAttack and
	    (V*.onGrid or V*.maze ~= 8 or V*.mazeLine < 8 or
	     V*.mazeLine > 12 or V*.mazeCol < 1 or V*.mazeCol > 6) and
	    PrevSetup and V*.Random(StealthLevel + 1) = 0 and
	    (V*.onGrid or V*.Random(254) < MazeCnt[V*.maze]) then
	if not V*.onGrid then
	    MazeCnt[V*.maze] := MazeCnt[V*.maze] - 2;
	fi;
    else
	V*.underAttack := false;
    fi;
corp;

/*
 * killMonster - any special actions after a monster is killed.
 */

proc killMonster()void:
    uint amount;

    Paralyzed := false;
    Doubled := false;
    amount := make(V*.monsterData.m_strength, uint)+V*.monsterData.m_hitPoints;
    if (V*.monsterData.m_pattern >= 15 and V*.monsterData.m_pattern <= 18 or
	    V*.monsterData.m_picture = 11 or V*.monsterData.m_picture = 14) and
	    V*.Random(if LuckTime ~= 0 then 2 else 3 fi) = 0 then
	pFind(
	    if LuckTime = 0 then
		(V*.Random(amount * 3) + amount) / 4
	    else
		amount
	    fi);
    elif V*.Random(if LuckTime ~= 0 then 6 else 10 fi) = 0 then
	learnSpell();
    fi;
    add(&V*.experience, amount / 8);
corp;

/*
 * calcHit - calculate current normal maximum hit points based on experience.
 */

proc calcHit()uint:

    if V*.experience < 5000 then
	V*.experience / 10 + 100
    else
	V*.experience / 50 + 500
    fi
corp;

/*
 * calcStr - calculate current normal strength based on experience.
 */

proc calcStr()uint:

    if V*.experience < 5000 then
	V*.experience / 100 + 10
    else
	V*.experience / 250 + 40
    fi
corp;

/*
 * calcCarry - calculate current carryweight based on strength.
 */

proc calcCarry()uint:

    V*.strength * 2 - 5
corp;

/*
 * condition - local routine used for fancy output in "stats".
 */

proc condition(uint time; *char cond; ushort level)void:
    *char p;

    if time ~= 0 then
	if FirstCondition then
	    V*.PMess("    Condition: ");
	    FirstCondition := false;
	    Col := 16;
	else
	    V*.PMess(", ");
	    Col := Col + 2;
	fi;
	p := cond;
	while p* ~= '\e' do
	    p := p + 1;
	    Col := Col + 1;
	od;
	if level ~= 1 then
	    Col := Col + 3;
	fi;
	if Col >= 80 then
	    V*.Pnl();
	    Col := 9;
	    V*.PMess("\t");
	fi;
	V*.PMess(cond);
	optNumber(level);
    fi;
corp;

/*
 * stats - print out any world-specific statistics.
 */

proc stats()void:
    ATTACK a;

    if SpellKnown then
	V*.PMess("    Magic Points: ");
	V*.PNumber(MagicPoints);
	V*.PutChar('/');
	V*.PNumber(SpellPoints / 10 + 1);
	V*.PMess("    \t");
	V*.PMess("Cleric Points: ");
	V*.PNumber(ClericPoints);
	V*.PutChar('/');
	V*.PNumber(SpellPoints);
	V*.Pnl();
    fi;
    FirstCondition := true;
    condition(BlessTime, "Blessed", 1);
    condition(LuckTime, "Lucky", 1);
    condition(ShieldTime, "Shielded", ShieldLevel);
    condition(StealthTime, "Stealthy", StealthLevel);
    condition(StrengthTime, "Strong", StrengthLevel);
    condition(VigorTime, "Vigorous", VigorLevel);
    if not FirstCondition then
	V*.Pnl();
    fi;
    FirstCondition := false;
    for a from A_PUNCTURE - 1 upto A_DISPELL - 1 do
	if ProtectLevel[a] ~= 0 then
	    FirstCondition := true;
	fi;
    od;
    if FirstCondition then
	V*.PMess("    Clerical protection:\n\t");
	for a from A_PUNCTURE upto A_DISPELL do
	    V*.PAttType(a);
	    V*.PMess(": ");
	    V*.PNumber(ProtectLevel[a - 1]);
	    V*.PutChar(' ');
	od;
	V*.Pnl();
    fi;
corp;
