#//old/include/explore.g
#//old/include/user.g
#amelon.g

extern
    beep()void,
    blocked()void,
    enterMaze()bool,
    goMaze(MAZE m; MAZELINE l; MAZECOL c; HEADING h)bool,
    store(uint priceFactor)void,
    armoury(uint priceFactor)void,
    stable(uint priceFactor)void,
    inn(uint priceFactor)void,
    tavern(uint priceFactor)void,
    church(uint priceFactor)void,
    dock(uint priceFactor)void;

bool Changed;

/*
 * gSetup - local routine to call f.GridSetup
 */

proc gSetup()void:

    PrevSetup := false;
    V*.onGrid := true;
    V*.GridSetup();
corp;

/*
 * goGrid - move out to a grid.
 */

proc goGrid(GRID g; GRIDLINE wT; GRIDCOL wL;
		    GRIDLINE l; GRIDCOL c)bool:

    V*.grid := g;
    V*.windowLineTop := wT;
    V*.windowColLeft := wL;
    V*.gridLine := l;
    V*.gridCol := c;
    gSetup();
    false
corp;

/*
 * smallGrid - move out to a small (8 x 8) grid.
 */

proc smallGrid(GRID g; GRIDLINE l; GRIDCOL c)bool:

    goGrid(g, 0, 0, l, c)
corp;

/*
 * exitMain - save status when exiting main grid.
 */

proc exitMain()void:

    MainLine := CheckLine;
    MainCol := CheckCol;
    MainWindowTop := V*.windowLineTop;
    MainWindowLeft := V*.windowColLeft;
    PrevSetup := false;
corp;

/*
 * enterMain - enter the main grid from a town/city/cave.
 */

proc enterMain()bool:

    goGrid(0, MainWindowTop, MainWindowLeft, MainLine, MainCol)
corp;

/*
 * horseCheck - check to see that he isn't riding his horse.
 */

proc horseCheck()bool:

    if OnHorse then
	V*.PText(60);
	false
    else
	true
    fi
corp;

/*
 * bType - return the type of the building to go into.
 */

proc bType()ushort:

    if CheckTerritory = 11 then
	CheckCol := CheckCol + 1;
	CheckTerritory := 12;
    fi;
    if V*.grid = 0 then
	2
    elif V*.grid = 2 and CheckLine = 1 then
	0
    elif V*.grid = 2 and CheckLine = 2 then
	3
    elif V*.grid = 6 then
	if CheckCol = 3 then
	    0
	else
	    CheckLine
	fi
    else
	(CheckLine + CheckCol) % 5
    fi
corp;

/*
 * building - check for and set up entry into a building.
 */

proc building()bool:

    if bType() = 2 and not OnCarpet or horseCheck() then
	GoBuilding := true;
	true
    else
	false
    fi
corp;

/*
 * tryChurch - try moving into a church.
 */

proc tryChurch()bool:

    if horseCheck() then
	GoChurch := true;
	true
    else
	false
    fi
corp;

/*
 * gridMove - check to see if proposed grid move is O.K.
 */

proc gridMove(GRIDLINE l; GRIDCOL c)bool:

    CheckLine := l;
    CheckCol := c;
    if l = V*.gridLine and c = V*.gridCol then
	true
    elif PrevSetup and l = PrevLine and c = PrevCol or
	    not V*.underAttack then
	PrevSetup := true;
	PrevLine := V*.gridLine;
	PrevCol := V*.gridCol;
	true
    else
	blocked();
	false
    fi
corp;

/*
 * gridSpec0 - handle grid specials for main grid.
 */

proc gridSpec0()bool:

    if OnBoat then
	if CheckTerritory = 10 or
		CheckTerritory = 13 and (CheckLine = 3 or CheckLine = 44) then
	    if CheckTerritory = 13 then
		exitMain();
		if CheckLine = 3 then
		    V*.PText(104);
		    HintCycle := 5;
		    goGrid(1, 0, 9, 0, 13)
		else
		    V*.PText(93);
		    GoDock := true;
		    HintCycle := 0;
		    goGrid(3, 0, 4, 0, 8)
		fi
	    else
		GoDock := true;
		true
	    fi
	elif CheckTerritory = 15 or CheckTerritory = 4 then
	    true
	elif CheckTerritory = 14 then
	    exitMain();
	    V*.PText(89);
	    if CheckLine = 2 then
		goGrid(5, 0, 5, 1, 9)
	    elif CheckLine = 30 then
		goGrid(5, 5, 11, 9, 17)
	    elif CheckLine = 59 then
		goGrid(5, 11, 5, 17, 9)
	    else
		goGrid(5, 5, 0, 9, 1)
	    fi
	elif CheckTerritory = 20 then
	    exitMain();
	    smallGrid(4, 0, 3)
	else
	    beep();
	    false
	fi
    else
	case CheckTerritory
	incase 3:
	    V*.PText(101);
	    exitMain();
	    HintCycle := 3;
	    smallGrid(7, 0, 4)
	incase 5:
	    if horseCheck() then
		V*.PText(145);
		exitMain();
		goMaze(46, 0, 3, WEST)
	    else
		false
	    fi
	incase 8:
	    if CheckLine = 8 then
		V*.PText(123);
		exitMain();
		smallGrid(10, 4, 0)
	    elif CheckLine = 38 then
		GoBuilding := true;
		true
	    elif CheckLine = 52 then
		V*.PText(100);
		exitMain();
		smallGrid(6, 0, 4)
	    else
		V*.PText(
		    if CheckLine = 25 then
			92
		    elif CheckLine = 35 then
			98
		    elif CheckLine = 36 then
			97
		    else
			91
		    fi
		);
		exitMain();
		smallGrid(2, 7, 4)
	    fi
	incase 9:
	    if horseCheck() then
		V*.PText(105);
		exitMain();
		goMaze(25, 3, 4, NORTH)
	    else
		false
	    fi
	incase 10:
	    GoDock := true;
	    true
	incase 13:
	    case CheckLine
	    incase 3:
		V*.PText(104);
		exitMain();
		HintCycle := 5;
		goGrid(1, 12, 2, 19, 6)
	    incase 4:
		exitMain();
		goMaze(37, 0, 6, SOUTH)
	    incase 26:
		V*.PText(118);
		exitMain();
		HintCycle := 4;
		goGrid(9, 4, 3, 11, 6)
	    incase 37:
		V*.PText(110);
		exitMain();
		HintCycle := 2;
		smallGrid(8, 7, 3)
	    incase 44:
		V*.PText(93);
		exitMain();
		HintCycle := 0;
		goGrid(3, 8, 4, 15, 8)
	    esac
	incase 21:
	    V*.PText(169);
	    true
	incase 25:
	    if horseCheck() then
		case CheckCol
		incase 4:
		    exitMain();
		    goMaze(41, 4, 0, EAST)
		incase 5:
		    exitMain();
		    goMaze(12, 0, 0, EAST)
		incase 9:
		    V*.PText(103);
		    exitMain();
		    goMaze(9, 0, 7, SOUTH)
		default:
		    false
		esac
	    else
		false
	    fi
	default:
	    true
	esac
    fi
corp;

/*
 * gSpec - inner portion of gridSpecial.
 */

proc gSpec()bool:

    case V*.grid
    incase 0:					/* main grid */
	gridSpec0()
    incase 1:					/* Aalluxi */
	if OnBoat then
	    if CheckTerritory = 10 then
		GoDock := true;
		true
	    elif CheckTerritory = 14 then
		enterMain()
	    else
		beep();
		false
	    fi
	else
	    if CheckTerritory = 0 then
		enterMain()
	    elif CheckTerritory = 7 and horseCheck() then
		goMaze(13, 0, 3, SOUTH)
	    elif CheckTerritory = 9 then
		tryChurch()
	    elif CheckTerritory = 10 then
		GoDock := true;
		true
	    else
		false
	    fi
	fi
    incase 3:					/* Asaru */
	if CheckTerritory = 3 then
	    enterMain()
	elif CheckTerritory = 9 and horseCheck() then
	    if CheckCol = 6 then
		V*.PText(95);
		goMaze(0, 10, 4, NORTH)
	    else
		V*.PText(94);
		goMaze(1, 0, 2, SOUTH)
	    fi
	elif CheckTerritory = 10 then
	    GoDock := true;
	    true
	elif CheckTerritory = 13 and horseCheck() then
	    V*.PText(96);
	    goMaze(3, 0, 4, SOUTH)
	elif CheckTerritory = 14 and OnBoat then
	    enterMain()
	else
	    beep();
	    false
	fi
    incase 4:					/* hidden dock */
	enterMain()
    incase 6:					/* Enbililugugal */
	if horseCheck() then
	    goMaze(43, 0, 0, SOUTH)
	else
	    beep();
	    false
	fi
    incase 7:					/* Ereshkigal */
	if horseCheck() then
	    goMaze(45, 0, 3, SOUTH)
	else
	    beep();
	    false
	fi
    incase 8:					/* Lumxi */
	if CheckTerritory = 0 then
	    enterMain()
	elif horseCheck() then
	    V*.PText(111);
	    goMaze(33, 0, 0, SOUTH)
	else
	    beep();
	    false
	fi
    incase 9:					/* Odun */
	if CheckLine = 11 then
	    enterMain()
	elif CheckLine = 10 then
	    ForceAttack := true;
	    V*.monsterNumber := 42;
	    true
	elif CheckLine = 5 then
	    tryChurch()
	elif not horseCheck() then
	    beep();
	    false
	else
	    if CheckLine = 0 then
		V*.PText(121);
		goMaze(39, 1, 2, SOUTH)
	    else
		V*.PText(122);
		goMaze(38,
		       if CheckLine = 4 then 6 else 15 fi,
		       if CheckCol = 5 then 0 else 7 fi,
		       if CheckLine = 4 then
			   if CheckCol = 5 then EAST else WEST fi
		       else
			   if CheckCol = 5 then WEST else EAST fi
		       fi)
	    fi
	fi
    incase 10:					/* Krogur */
	if CheckCol = 0 then
	    enterMain()
	elif CheckCol = 1 then
	    tryChurch()
	elif CheckCol = 15 then
	    goMaze(36, 3, 0, EAST)
	else
	    if horseCheck() then
		V*.maze := 40;
		V*.heading := EAST;
		if CheckCol = 11 then
		    V*.heading := WEST;
		    V*.mazeLine := 3;
		    V*.mazeCol := 8;
		elif CheckCol = 8 then
		    V*.mazeLine := 4;
		    V*.mazeCol := 2;
		else
		    V*.mazeLine := if CheckLine = 0 then 1 else 7 fi;
		    V*.mazeCol := 0;
		fi;
		enterMaze()
	    else
		beep();
		false
	    fi
	fi
    incase 11:					/* Hidden town */
	if horseCheck() then
	    if CheckLine = 2 then
		V*.PText(
		    if GotSword then
			128
		    else
			GotSword := true;
			V*.Place(15, true, 11, 2, 7);
			127
		    fi);
		true
	    else
		pretend(goMaze(42, 2, 0, EAST), void);
		V*.SetTopPalette(0);
		V*.PicDisp(23);
		false
	    fi
	else
	    beep();
	    false
	fi
    default:
	true
    esac
corp;

/*
 * gridSpec - see if O.K. to walk onto a special grid square.
 *	      All 'false' cases must either change the display or call
 *	      beep to let the user know that the move is invalid.
 */

proc gridSpec(GRIDLINE line; GRIDCOL col; TERRITORY t; ushort group)bool:

    if gridMove(line, col) then
	CheckTerritory := t;
	OnCarpet or gSpec()
    else
	false
    fi
corp;

/*
 * gridNorm2 - special gridNorm case for grid 2 - Ika and Oka.
 */

proc gridNorm2()bool:

    if CheckTerritory = 3 then
	Changed := true;
	enterMain()
    elif CheckTerritory = 7 then
	horseCheck()
    elif CheckTerritory = 8 then
	building()
    elif CheckTerritory = 9 then
	if (MainLine = 35 or MainLine = 36) and CheckLine = 5 then
	    if horseCheck() then
		V*.PText(112);
		goMaze(if MainLine = 36 then 34 else 35 fi, 0, 0, SOUTH)
	    else
		false
	    fi
	else
	    tryChurch()
	fi
    else
	CheckTerritory ~= 1 and CheckTerritory ~= 2
    fi
corp;

/*
 * gridNorm5 - special gridNorm case for grid 5 - Atlantis.
 */

proc gridNorm5()bool:

    if OnBoat then
	if CheckTerritory = 6 then
	    V*.PText(88);
	    Changed := true;
	    if CheckLine = 1 then
		goGrid(0, 0, 43, 2, 47)
	    elif CheckLine = 17 then
		goGrid(0, 55, 31, 59, 35)
	    elif CheckCol = 1 then
		goGrid(0, 34, 0, 38, 1)
	    else
		goGrid(0, 26, 56, 30, 61)
	    fi
	else
	    if CheckTerritory = 8 then
		GoDock := true;
		true
	    else
		CheckTerritory = 14
	    fi
	fi
    else
	if CheckTerritory = 5 then
	    if horseCheck() then
		Changed := true;
		goMaze(8, 0, 0, SOUTH)
	    else
		false
	    fi
	else
	    if CheckTerritory = 8 then
		GoDock := true
	    fi;
	    CheckTerritory ~= 14
	fi
    fi
corp;

/*
 * gNorm - inner level code for gridNorm.
 */

proc gNorm()bool:

    case V*.grid
    incase 0:					/* main grid */
	if OnBoat then
	    CheckTerritory = 4 or CheckTerritory = 6 or
	    CheckTerritory = 14 or CheckTerritory = 15 or
	    CheckTerritory >= 29 and CheckTerritory <= 40
	else
	    CheckTerritory ~= 14 and CheckTerritory ~= 20 and
	    (CheckTerritory < 29 or CheckTerritory > 40)
	fi
    incase 1:					/* Aalluxi */
	if OnBoat then
	    CheckTerritory = 14 or
		CheckTerritory >= 29 and CheckTerritory <= 40
	else
	    if CheckTerritory = 8 or CheckTerritory = 11 or
		    CheckTerritory = 12 then
		building()
	    elif CheckTerritory = 7 then
		horseCheck()
	    else
		CheckTerritory ~= 14 and CheckTerritory ~= 20 and
		(CheckTerritory < 29 or CheckTerritory > 40)
	    fi
	fi
    incase 2:					/* Ika and Oka */
	gridNorm2()
    incase 3:					/* Asaru */
	if OnBoat then
	    CheckTerritory = 14
	else
	    if CheckTerritory = 3 then
		CheckCol = 8
	    elif CheckTerritory = 7 then
		horseCheck()
	    elif CheckTerritory = 8 then
		building()
	    elif CheckTerritory = 9 then
		tryChurch()
	    else
		CheckTerritory ~= 1 and CheckTerritory ~= 2
	    fi
	fi
    incase 4:					/* hidden dock */
	GoDock := CheckTerritory = 10;
	if OnBoat then
	    CheckTerritory = 14 or CheckTerritory = 10
	else
	    if CheckLine = 1 and CheckCol ~= 1 then
		if horseCheck() then
		    V*.PText(125);
		    pretend(goMaze(42, 0, 2, SOUTH), void);
		    V*.SetTopPalette(0);
		    V*.PicDisp(23);
		fi;
		false
	    else
		CheckTerritory ~= 14 and CheckTerritory ~= 3
	    fi
	fi
    incase 5:					/* Atlantis */
	gridNorm5()
    incase 6:					/* Enbililugugal */
    incase 7:					/* Eriskigal */
    incase 8:					/* Lumxi */
    incase 9:					/* Odun */
    incase 11:					/* hidden town */
	if CheckTerritory = 0 and CheckLine = 0 then
	    Changed := true;
	    enterMain()
	elif CheckTerritory = 7 then
	    horseCheck()
	elif CheckTerritory = 8 then
	    building()
	elif CheckTerritory = 9 or CheckTerritory = 5 then
	    tryChurch()
	else
	    CheckTerritory = 0 or CheckTerritory = 17
	fi
    incase 10:					/* Krogur */
	if CheckTerritory = 25 then
	    building()
	else
	    CheckTerritory = 0 or CheckTerritory = 21 or CheckTerritory = 27
	fi
    default:
	false
    esac
corp;

/*
 * gridNorm - see if O.K. to walk onto a normal grid square.
 *	      All 'false' cases must either change the display or call
 *	      beep to let the user know that the move is invalid.
 */

proc gridNorm(GRIDLINE line; GRIDCOL col; TERRITORY t; ushort group)bool:

    if gridMove(line, col) then
	CheckTerritory := t;
	if OnCarpet then
	    true
	else
	    Changed := false;
	    if gNorm() then
		true
	    else
		if not Changed then
		    beep();
		fi;
		false
	    fi
	fi
    else
	false
    fi
corp;

/*
 * gridMoved - a move has been made on a grid; check for specials.
 */

proc gridMoved()void:
    uint valu;

    valu := (CheckLine % 11 + CheckCol % 11) + 10;
    if GoBuilding then
	GoBuilding := false;
	case bType()
	incase 0:
	    store(valu);
	incase 1:
	    armoury(valu);
	incase 2:
	    stable(valu);
	incase 3:
	    inn(valu);
	incase 4:
	    tavern(valu);
	esac;
    elif GoChurch then
	GoChurch := false;
	church(valu);
    elif GoDock then
	GoDock := false;
	dock(valu);
    elif ForceAttack then
	ForceAttack := false;
	V*.underAttack := true;
	V*.MAtt();
    fi;
corp;
