#//old/include/explore.g
#//old/include/user.g
#amelon.g

extern
    CharsEqual(*char p, q)bool;

extern
    beep()void,
    goGrid(GRID g; GRIDLINE wT; GRIDCOL wL; GRIDLINE l; GRIDCOL c)bool,
    smallGrid(GRID g; GRIDLINE l; GRIDCOL c)bool,
    elevator()void,
    enterMain()bool,
    blocked()void,
    showPiece()void,
    pFind(uint amount)void;

/*
 * turnRight - rotate heading right 90 degrees.
 */

proc turnRight()void:

    V*.heading := (V*.heading + 1 - NORTH) % range(HEADING) + NORTH;
corp;

/*
 * turnLeft - rotate heading left 90 degrees.
 */

proc turnLeft()void:

    V*.heading := (V*.heading + (range(HEADING) - 1) - NORTH) %
			    range(HEADING) + NORTH;
corp;

/*
 * turnAround - rotate heading by 180 degrees.
 */

proc turnAround()void:

    V*.heading := (V*.heading + (range(HEADING) / 2) - NORTH) %
			    range(HEADING) + NORTH;
corp;

/*
 * mSetup - local routine to call V*.MazeSetup
 */

proc mSetup()void:

    V*.maxView :=
	if PassageDepth > 4 then
	    1
	else
	    5 - PassageDepth
	fi;
    V*.onGrid := false;
    PrevSetup := false;
    V*.MazeSetup();
corp;

/*
 * enterMaze - utility routine to enter a maze.
 */

proc enterMaze()bool:

    PassageDepth := 0;
    mSetup();
    false
corp;

/*
 * newMazeUp - go to a new maze climbing up a ladder.
 */

proc newMazeUp()void:

    PassageDepth := PassageDepth - 1;
    mSetup();
corp;

/*
 * nMU1 - go up to a new maze.
 */

proc nMU1(MAZE m; MAZELINE l; MAZECOL c)void:

    V*.maze := m;
    V*.mazeLine := l;
    V*.mazeCol := c;
    newMazeUp();
corp;

/*
 * newMazeDown - go to a new maze below this one.
 */

proc newMazeDown()void:

    PassageDepth := PassageDepth + 1;
    mSetup();
corp;

/*
 * nMD1 - go down to a new maze.
 */

proc nMD1(MAZE m; MAZELINE l; MAZECOL c)void:

    V*.maze := m;
    V*.mazeLine := l;
    V*.mazeCol := c;
    newMazeDown();
corp;

/*
 * mMove - move to a new position in the same maze.
 */

proc mMove(MAZELINE line; MAZECOL col)void:

    V*.mazeLine := line;
    V*.mazeCol := col;
    mSetup();
corp;

/*
 * goMaze - go into a maze from a grid.
 */

proc goMaze(MAZE m; MAZELINE l; MAZECOL c; HEADING h)bool:

    V*.maze := m;
    V*.mazeLine := l;
    V*.mazeCol := c;
    V*.heading := h;
    enterMaze()
corp;

/*
 * goMaze1 - go into a new maze from another maze.
 */

proc goMaze1(MAZE m; MAZELINE l; MAZECOL c)bool:

    V*.maze := m;
    V*.mazeLine := l;
    V*.mazeCol := c;
    mSetup();
    false
corp;

/*
 * mazeSpec - walk onto a special maze square.
 */

proc mazeSpec()void:

    case V*.maze
    incase 5:					/* Fort Asaru, Dungeon 1 */
	if V*.mazeLine = 6 then
	    if not SeenPris then
		SeenPris := true;
		V*.PText(106);
		V*.Carry(23);
	    fi;
	else
	    V*.Print("You feel a momentary sense of disorientation.");
	    turnRight();
	fi;
    incase 8:					/* Atlanean temple */
	if V*.mazeLine = 1 and V*.mazeCol ~= 11 or
		V*.mazeLine = 3 and V*.mazeCol ~= 12 then
	    V*.PText(115);
	elif V*.mazeLine <= 3 then
	    V*.PText(116);
	elif V*.mazeCol = 12 then
	    V*.PText(87);
	else
	    showPiece();
	fi;
    incase 13:
    incase 14:
    incase 15:
    incase 19:
	GoElevator := true;
    incase 16:
	if V*.mazeLine = 4 and V*.mazeCol = 7 then
	    GoElevator := true;
	elif V*.mazeLine = 2 then
	    V*.PText(33);
	    if V*.IsCarrying(33) then
		mMove(7, 1);
	    fi;
	elif V*.mazeLine = 7 then
	    V*.PText(33);
	    mMove(2, 7);
	else
	    if V*.mazeLine = 3 and V*.mazeCol = 3 then
		V*.PText(34);
	    fi;
	    ForceAttack := true;
	    WhichMon := 35;
	fi;
    incase 17:
	if V*.mazeCol = 7 then
	    GoElevator := true;
	else
	    V*.PText(41);
	    mMove(V*.mazeLine,
		if V*.mazeCol = 5 then
		    1
		else
		    V*.mazeCol + 2
		fi);
	fi;
    incase 18:
	if V*.mazeCol = 7 then
	    GoElevator := true;
	else
	    turnAround();
	fi;
    incase 20:
	if V*.mazeLine = 4 then
	    GoElevator := true;
	else
	    V*.PText(40);
	    LightsOn := LastLightDoor = 0 and V*.mazeCol = 1 or
		    LastLightDoor = 1 and V*.mazeCol = 0;
	    LastLightDoor := if V*.mazeLine = 3 then 0 else 2 fi + V*.mazeCol;
	fi;
    incase 21:
	if V*.mazeLine = 4 and V*.mazeCol = 7 then
	    GoElevator := true;
	else
	    V*.PText(43);
	    /* special - keep lights on */
	    V*.mazeLine := 7;
	    V*.mazeCol := 7;
	    PrevSetup := false;
	    V*.MazeSetup();
	fi;
    incase 22:
	if V*.mazeLine = 4 and V*.mazeCol = 7 then
	    GoElevator := true;
	else
	    while
		V*.mazeLine := V*.Random(8);
		V*.mazeCol := V*.Random(8);
		PrevSetup := false;
		V*.MazeSetup();
		V*.PText(71);
		V*.GConf(V*.mazeLine, V*.mazeCol) >> 4 + M_EMPTY ~= M_EMPTY
	    do
	    od;
	fi;
    incase 23:
	if V*.mazeLine = 4 then
	    GoElevator := true;
	else
	    ForceAttack := true;
	    WhichMon := 47 + 7 - V*.mazeCol;
	fi;
    incase 24:					/* bottom level of house */
	if V*.mazeCol = 2 then
	    ForcePic := true;
	    WhichPic :=
		if V*.mazeLine = 1 then
		    25
		elif V*.mazeLine = 5 then
		    27
		else
		    28
		fi;
	elif V*.mazeCol = 3 then
	    if not ZontallahDead then
		ForceAttack := true;
		WhichMon := 0;
	    fi;
	elif V*.mazeCol = 5 then
	    ForcePic := true;
	    WhichPic := 26;
	else
	    V*.PText(
		if V*.mazeCol = 4 then
		    62
		elif V*.mazeCol = 6 then
		    V*.mazeLine + 63
		else
		    V*.mazeLine + 148
		fi
	    );
	    if V*.mazeCol = 7 and V*.mazeLine = 4 then
		ForcePic := true;
		WhichPic := 24;
	    fi;
	fi;
    incase 33:					/* Fort Lumxi */
	if not GotMoney then
	    GotMoney := true;
	    ForcePic := true;
	    WhichPic := 18;
	    pFind(10000);
	    beep();
	fi;
    incase 38:
	V*.PText(
	    if V*.mazeLine = 0 then
		119
	    else
		120
	    fi);
    incase 41:
	V*.PText(124);
    incase 42:
	ForceAttack := true;
	WhichMon := 98;
    incase 43:
	V*.PText(129);
	V*.maze := 44;
	newMazeDown();
    incase 45:
	mMove(if V*.mazeLine = 1 then 5 else 1 fi, V*.mazeCol);
    incase 46:
	V*.PText(146);
    esac;
corp;

/*
 * closed - a door won't open.
 */

proc closed()bool:

    V*.Print("The door won't open.\(BEL)");
    false
corp;

/*
 * elDoor - check for the elevator door.
 */

proc elDoor()bool:

    if V*.IsCarrying(32) then
	true
    else
	closed()
    fi
corp;

/*
 * mazeSpecDoor - see if O.K. to go through a maze special door.
 */

proc mSD1(MAZELINE line; MAZECOL col)bool:

    case V*.maze
    incase 20:
	if line = 5 then
	    elDoor()
	else
	    InDark := not InDark;
	    V*.maxView :=
		if InDark and not LightsOn then
		    V*.PText(47);
		    0
		else
		    1
		fi;
	    true
	fi
    incase 23:
	if line = 5 then
	    elDoor()
	else
	    V*.mazeLine = 1 or closed()
	fi
    incase 24:
	if line = 5 then
	    V*.mazeLine = 4 or closed()
	else
	    if V*.mazeLine = 5 and not ZontallahDead then
		ForceAttack := true;
		WhichMon := 97;
	    fi;
	    true
	fi
    incase 33:
	smallGrid(8, 3, 5)
    incase 36:
	goGrid(10, 0, 12, 2, 15)
    incase 37:
    incase 41:
	pretend(enterMain(), void);
	true
    incase 39:
	goGrid(9, 0, 2, 0, 6)
    incase 40:
	goGrid(10, 0,
	    if line = 3 then 8 else 3 fi,
	    case line
	    incase 1:
		0
	    incase 3:
		1
	    incase 4:
		2
	    incase 7:
		4
	    esac,
	    if line = 4 then
		8
	    elif line = 3 then
		11
	    else
		7
	    fi)
    incase 42:
	if line = 0 then
	    smallGrid(4, 1, 5)
	else
	    V*.PText(126);
	    smallGrid(11, 3, 2)
	fi
    incase 43:
	smallGrid(6, 6, 1)
    incase 45:
	smallGrid(7, 6, 5)
    incase 46:
	if col = 4 then
	    pretend(enterMain(), void);
	    true
	elif col = 3 and StaffGone then
	    pretend(goMaze(46, 0, 4, EAST), void);
	    V*.PText(168);
	    V*.gameOver := true;
	    false
	else
	    closed()
	fi
    default:
	false
    esac
corp;

proc mazeSpecDoor(MAZELINE line; MAZECOL col; bool isHor)bool:

    case V*.maze
    incase 0:
	goGrid(3, 3, 2, 7, 6)
    incase 1:
	goGrid(3, 3, 0, 7, 4)
    incase 3:
	goGrid(3, 2, 4, 6, 8)
    incase 4:
	V*.heading := EAST;
	goMaze1(7, 0, 0)
    incase 5:
	if
	    if isHor then
		line = V*.mazeLine
	    elif line = 3 and col = 4 or line = 5 and col = 5 then
		col ~= V*.mazeCol
	    else
		col = V*.mazeCol
	    fi
	then
	    true
	else
	    closed()
	fi
    incase 6:
	if line = 2 then
	    if V*.IsCarrying(23) and V*.IsCarrying(24) and
		    V*.IsCarrying(25) then
		true
	    else
		closed()
	    fi
	elif line = 3 then
	    if V*.mazeLine = 3 then
		V*.PText(107);
	    fi;
	    true
	else
	    V*.mazeLine :=
		if line = 0 then
		    8
		else
		    0
		fi;
	    V*.MazeDisplay();
	    false
	fi
    incase 7:
	goMaze1(4, 3, 8)
    incase 8:
	if line = 1 then
	    if V*.mazeLine = 0 then
		V*.PText(114);
	    fi;
	    true
	elif line = 0 or line = 6 then
	    goGrid(5, 8, 7, 12, 11)
	elif line = 8 then
	    if V*.mazeLine = 8 then
		V*.mazeLine := 2;
		V*.MazeDisplay();
		false
	    else
		true
	    fi
	else
	    if isHor then
		if V*.mazeLine = 9 then
		    V*.PText(117);
		fi;
		true
	    else
		if V*.mazeCol = 5 then
		    true
		else
		    if DroppedSword then
			V*.PText(147);
			true
		    else
			closed()
		    fi
		fi
	    fi
	fi
    incase 9:
	if MainCol ~= 9 then
	    MainCol := 9;
	    if MainWindowLeft < 3 then
		MainWindowLeft := 3;
	    fi;
	fi;
	enterMain()
    incase 13:
	if line = 0 then
	    goGrid(1, 12, 12, 16, 17)
	else
	    elDoor()
	fi
    incase 14:
    incase 15:
    incase 17:
    incase 21:
    incase 22:
	elDoor()
    incase 16:
	if line = 5 then
	    elDoor()
	else
	    col = V*.mazeCol or closed()
	fi
    incase 18:
	if col = 7 then 
	    elDoor()
	elif col = 2 or line = 1 then
	    V*.mazeLine = line or closed()
	elif line = 2 then
	    V*.mazeCol ~= col or closed()
	elif line = 0 then
	    V*.PText(if DoorParity then 35 else 36 fi);
	    DoorParity := not DoorParity;
	    true
	else
	    if not DoorParity then
		V*.PText(35);
		false
	    else
		true
	    fi
	fi
    incase 19:
	if col = 7 then
	    elDoor()
	elif col = 5 then
	    line = V*.mazeLine or closed()
	else
	    RotatePosition := (RotatePosition + 1) % 4;
	    V*.PText(37);
	    true
	fi
    default:
	mSD1(line, col)
    esac
corp;

/*
 * mazeUp - move up when playing in a maze.
 */

proc mazeUp()void:

    case V*.maze
    incase 2:
	if V*.mazeCol = 0 then
	    turnAround();
	    nMU1(1, 7, 5);
	else
	    nMU1(0, 1, 7);
	fi;
    incase 6:
	nMU1(5, 4, 2);
    incase 7:
	turnAround();
	nMU1(0, 2, 2);
    incase 10:
	if PassageDepth = 1 then
	    turnRight();
	    nMU1(9, 13, 14);
	else
	    V*.mazeCol := 0;
	    newMazeUp();
	fi;
    incase 11:
	V*.mazeCol :=
	    if V*.mazeCol = 0 then
		V*.maze := 12;
		1
	    else
		V*.maze := 10;
		0
	    fi;
	newMazeUp();
    incase 12:
	if PassageDepth = 0 then
	    if MainCol ~= 5 then
		MainCol := 5;
		if MainWindowLeft > 4 then
		    MainWindowLeft := 4;
		fi;
	    fi;
	    pretend(enterMain(), void);
	else
	    V*.mazeCol := 1;
	    newMazeUp();
	fi;
    incase 4:
    incase 5:
    incase 14:
    incase 15:
    incase 16:
    incase 17:
    incase 18:
    incase 21:
    incase 26:
    incase 27:
    incase 28:
    incase 29:
    incase 30:
    incase 31:
    incase 32:
    incase 44:
	V*.maze := V*.maze - 1;
	newMazeUp();
    incase 19:
	if RotatePosition = 0 then
	    V*.maze := V*.maze - 1;
	    newMazeUp();
	else
	    V*.PText(38);
	fi;
    incase 20:
	nMU1(19, 6, 6);
    incase 22:
	PassageDepth := PassageDepth - 1;
	V*.maxView := 5;
	V*.maze := 21;
	V*.MazeSetup();
	PrevSetup := false;
    incase 23:
	PassageDepth := PassageDepth - 1;
	V*.maxView := 0;
	V*.maze := 22;
	V*.MazeSetup();
	PrevSetup := false;
	V*.PText(47);
    incase 24:
	if V*.mazeLine = 1 then
	    V*.maze := 23;
	    MagicDisabled := false;
	    newMazeUp();
	else
	    mMove(7, 5);
	fi;
    incase 25:
	pretend(enterMain(), void);
    incase 34:
    incase 35:
	pretend(goGrid(2, 0, 0, 5, 1), void);
    incase 38:
	if V*.mazeLine = 0 then
	    pretend(goMaze1(39, 4, 2), void);
	    V*.PText(121);
	else
	    pretend(goGrid(
		    9,
		    3,
		    if V*.mazeCol = 0 then 2 else 4 fi,
		    if V*.mazeLine = 6 then 4 else 9 fi,
		    if V*.mazeCol = 0 then 5 else 7 fi)
		    , void);
	fi;
    esac;
corp;

/*
 * mazeDown - move down when playing in a maze.
 */

proc mazeDown()void:

    case V*.maze
    incase 0:
	if V*.mazeLine = 1 then
	    nMD1(2, 0, 19);
	else
	    turnAround();
	    nMD1(7, 0, 9);
	fi;
    incase 1:
	turnAround();
	nMD1(2, 0, 0);
    incase 5:
	nMD1(6, 4, 7);
    incase 9:
	turnLeft();
	nMD1(10, 0, 1);
    incase 10:
	V*.mazeCol :=
	    if PassageDepth = 5 then
		V*.maze := 11;
		29
	    else
		1
	    fi;
	newMazeDown();
    incase 12:
	if PassageDepth = 5 then
	    V*.maze := 11;
	fi;
	V*.mazeCol := 0;
	newMazeDown();
    incase 3:
    incase 4:
    incase 13:
    incase 14:
    incase 15:
    incase 16:
    incase 17:
    incase 18:
    incase 22:
    incase 25:
    incase 26:
    incase 27:
    incase 28:
    incase 29:
    incase 30:
    incase 31:
    incase 43:
	V*.maze := V*.maze + 1;
	newMazeDown();
    incase 19:
	if RotatePosition = 1 then
	    nMD1(20, 6, 1);
	else
	    V*.PText(39);
	fi;
    incase 20:
	PassageDepth := PassageDepth + 1;
	V*.maxView := 5;
	V*.maze := 21;
	V*.MazeSetup();
	PrevSetup := false;
	V*.PText(42);
    incase 21:
	PassageDepth := PassageDepth + 1;
	V*.maxView := 0;
	V*.maze := 22;
	V*.MazeSetup();
	PrevSetup := false;
	V*.PText(47);
    incase 23:
	MagicDisabled := true;
	V*.maze := 24;
	newMazeDown();
	V*.PText(70);
    incase 24:
	mMove(2, 0);
    incase 39:
	pretend(goMaze1(38, 0, 3), void);
	V*.PText(122);
    esac;
corp;

/*
 * mazeMove - see if attempted move in maze is O.K.
 */

proc mazeMove(MAZELINE l; MAZECOL c)bool:

    if l = V*.mazeLine and c = V*.mazeCol then
	true
    elif PrevSetup and l = PrevLine and c = PrevCol or
	    not V*.underAttack then
	PrevSetup := true;
	PrevLine := V*.mazeLine;
	PrevCol := V*.mazeCol;
	true
    else
	blocked();
	false
    fi
corp;

/*
 * mazeMoved - a move has been made on a maze - check for specials.
 */

proc mazeMoved()void:
    [11] char buffer;
    *char p;

    if GoElevator then
	GoElevator := false;
	elevator();
    elif ForceAttack then
	ForceAttack := false;
	if
	    if WhichMon = 0 then
		V*.SetTopPalette(0);
		V*.PicDisp(29);
		V*.ReadChars("Password? ", &buffer[0], 11);
		p := &buffer[0];
		while p* ~= '\e' do
		    p* := V*.Cap(p*);
		    p := p + 1;
		od;
		if CharsEqual(&buffer[0], "CHAT") then
		    V*.PText(188);
		    false
		else
		    V*.PText(189);
		    true
		fi
	    else
		true
	    fi
	then
	    V*.underAttack := true;
	    V*.monsterNumber := WhichMon;
	    V*.MAtt();
	fi;
    elif ForcePic then
	ForcePic := false;
	V*.SetTopPalette(0);
	V*.PicDisp(WhichPic);
    elif V*.maze = 42 then
	V*.SetTopPalette(0);
	V*.PicDisp(23);
    fi;
corp;
