#//old/include/explore.g
#//old/include/user.g
#amelon.g

int MAXSPELL = 12;

uint
    SPELLTIME = 3;		/* number of days a spell lasts */
ushort
    SHFAC = 15, 		/* shield factor */
    PRFAC = 30, 		/* protect factor */
    HFAC = 20,			/* harm factor */
    ATFAC = 240,		/* attack factor */
    COMPFAC = 60,		/* companion attack factor */
    VFAC = 20,			/* vigor factor */
    STFAC = 10, 		/* strength factor */
    COSTFAC = 1,		/* cost factor */
    CUREFAC = 50;		/* cure factor */
short
    WKFAC = 10; 		/* weaken factor */

extern
    optNumber(ushort n)void,
    beep()void,
    pHit1(ATTACK a; uint force)void,
    getObName(OBJECT o)*char,
    calcCarry()uint;

bool WantNumber;
ushort Count, Spell;
[MAXSPELL] ushort SpellMax, SpellNumber;
[MAXSPELL] bool SpellBool;
ATTACK At;
ushort Temp;
uint WTemp;

/*
 * eatFood - a 'day' has passed - check for need to eat food.
 */

proc eatFood()void:

    if V*.food = 0 then
	V*.health :=
	    if V*.health < 10 then
		0
	    else
		V*.health - 10
	    fi;
	V*.PText(
	    if V*.health = 0 then
		V*.gameOver := true;
		6
	    else
		5
	    fi);
    elif not OnBoat and not OnCarpet then
	V*.food :=
	    if OnHorse or not V*.onGrid or V*.grid ~= 0 then
		V*.food - 1
	    elif V*.food >= 3 then
		V*.food - 3
	    else
		0
	    fi;
	if V*.food = 0 then
	    V*.PText(4);
	fi;
    fi;
corp;

/*
 * expireCheck - check to see if a some spell(s) is about to expire.
 */

proc expireCheck()void:
    *uint p;
    uint temp;
    bool gotOne;

    gotOne := false;
    if BlessTime ~= 0 then
	BlessTime := BlessTime - 1;
	if BlessTime = 0 then
	    gotOne := true;
	    for p from &V*.protection[A_PUNCTURE - 1] by sizeof(uint)
		  upto &V*.protection[A_DISPELL - 1] do
		p* := p* - 1;
	    od;
	    V*.protection[A_DISPELL - 1] := V*.protection[A_DISPELL - 1] - 4;
	fi;
    fi;
    if LuckTime ~= 0 then
	LuckTime := LuckTime - 1;
	if LuckTime = 0 then
	    gotOne := true;
	fi;
    fi;
    if ShieldTime ~= 0 then
	ShieldTime := ShieldTime - 1;
	if ShieldTime = 0 then
	    gotOne := true;
	    for p from &V*.protection[A_PUNCTURE - 1] by sizeof(uint)
		  upto &V*.protection[A_DISPELL - 1] do
		p* := p* - ShieldLevel * SHFAC;
	    od;
	    ShieldLevel := 0;
	fi;
    fi;
    if StealthTime ~= 0 then
	StealthTime := StealthTime - 1;
	if StealthTime = 0 then
	    gotOne := true;
	    StealthLevel := 0;
	fi;
    fi;
    if VigorTime ~= 0 then
	VigorTime := VigorTime - 1;
	if VigorTime = 0 then
	    gotOne := true;
	    V*.hitPoints := V*.hitPoints - VigorLevel * VFAC;
	    VigorLevel := 0;
	fi;
    fi;
    if StrengthTime ~= 0 then
	StrengthTime := StrengthTime - 1;
	if StrengthTime = 0 then
	    gotOne := true;
	    V*.strength := V*.strength - StrengthLevel * STFAC;
	    StrengthLevel := 0;
	    V*.maxCarryWeight := calcCarry();
	fi;
    fi;
    for At from A_PUNCTURE - 1 upto A_DISPELL - 1 do
	temp := ProtectTime[At];
	if temp ~= 0 then
	    temp := temp - 1;
	    ProtectTime[At] := temp;
	    if temp = 0 then
		gotOne := true;
		V*.protection[At] :=
		    V*.protection[At] - ProtectLevel[At] * PRFAC;
		ProtectLevel[At] := 0;
	    fi;
	fi;
    od;
    if gotOne then
	V*.PText(30);
    fi;
corp;

/*
 * toc - a large unit of time has gone by.
 */

proc toc()void:

    eatFood();
    if not V*.gameOver then
	expireCheck();
    fi;
corp;

/*
 * tic - a small unit of time has gone by.
 */

proc tic()void:

    if not V*.gameOver then
	if V*.onGrid and V*.grid = 0 then
	    toc();
	else
	    Tic := Tic + 1;
	    if Tic = MAXTICS then
		Tic := 0;
		toc();
	    fi;
	fi;
    fi;
corp;

/*
 * supply an optional spell number.
 */

proc num()void:

    V*.PutChar('\t');
    if WantNumber then
	Count := Count + 1;
	V*.PNumber(Count);
	V*.PMess(") ");
    fi;
corp;

/*
 * pSp - print out a spell and it's level.
 */

proc pSp(*char name; ushort max; bool pBool)void:

    if max ~= 0 then
	SpellNumber[Count] := Spell;
	SpellMax[Count] := max;
	SpellBool[Count] := pBool or max = 1;
	num();
	V*.PMess(name);
	if not pBool then
	    optNumber(max);
	fi;
	V*.Pnl();
    fi;
    Spell := Spell + 1;
corp;

/*
 * addSp - add a spell to the spell list.
 */

proc addSp()void:

    SpellNumber[Count] := Spell;
    SpellMax[Count] := Temp;
    SpellBool[Count] := Temp = 1;
corp;

/*
 * magicList - list out known magic spells.
 */

proc magicList()void:

    Count := 0;
    Spell := 0;
    V*.Print("\nMagic Spells:");
    for At from A_PUNCTURE upto A_DISPELL do
	Temp := AttackMax[At - 1];
	if Temp ~= 0 then
	    addSp();
	    num();
	    V*.PMess("Magical ");
	    V*.PAttType(At);
	    optNumber(Temp);
	    V*.Pnl();
	fi;
	Spell := Spell + 1;
    od;
    pSp("Stealth", StealthMax, false);
    pSp("Strength", StrengthMax, false);
    pSp("Harm", HarmMax, false);
    pSp("Double", if DoubleKnown then 4 else 0 fi, true);
    pSp("Weaken", if WeakenKnown then 3 else 0 fi, true);
corp;

/*
 * clericList - list all known cleric spells.
 */

proc clericList()void:

    Count := 0;
    Spell := 0;
    V*.Print("\nCleric Spells:");
    for At from A_PUNCTURE upto A_DISPELL do
	Temp := ProtectMax[At - 1];
	if Temp ~= 0 then
	    addSp();
	    num();
	    V*.PMess("Clerical ");
	    V*.PAttType(At);
	    V*.PMess(" Protection");
	    optNumber(Temp);
	    V*.Pnl();
	fi;
	Spell := Spell + 1;
    od;
    pSp("Cure", CureMax, false);
    pSp("Shield", ShieldMax, false);
    pSp("Vigor", VigorMax, false);
    pSp("Paralyze", if ParalyzeKnown then 3 else 0 fi, true);
    pSp("Luck", if LuckKnown then 2 else 0 fi, true);
    pSp("Locate", if LocateKnown then 1 else 0 fi, true);
corp;

/*
 * spellBook - list out the currently known spells.
 */

proc spellBook()void:

    WantNumber := false;
    magicList();
    clericList();
corp;

/*
 * learnSpell - learn a random spell if appropriate.
 */

proc learnSpell()void:
    *ushort pLevel;
    *bool pBool;
    ushort maxLevel;
    bool isBool, gotOne, canKnow;

    maxLevel :=
	if V*.experience < 1000 then
	    0
	elif V*.experience < 3162 then
	    1
	elif V*.experience < 10000 then
	    2
	elif V*.experience < 31623 then
	    3
	else
	    4
	fi;
    if maxLevel ~= 0 then
	isBool := false;
	if V*.Random(2) = 0 then
	    /* a magic spell */
	    Temp := V*.Random(11);
	    case Temp
	    incase 10:
		isBool := true;
		pBool := &WeakenKnown;
		canKnow := maxLevel >= 3;
	    incase 9:
		isBool := true;
		pBool := &DoubleKnown;
		canKnow := maxLevel = 4;
	    incase 8:
		pLevel := &HarmMax;
	    incase 7:
		pLevel := &StrengthMax;
	    incase 6:
		pLevel := &StealthMax;
	    default:
		pLevel := &AttackMax[Temp];
	    esac;
	else
	    /* a cleric spell */
	    Temp := V*.Random(12);
	    case Temp
	    incase 11:
		isBool := true;
		pBool := &ParalyzeKnown;
		canKnow := maxLevel >= 3;
	    incase 10:
		isBool := true;
		pBool := &LocateKnown;
		canKnow := true;
	    incase 9:
		isBool := true;
		pBool := &LuckKnown;
		canKnow := maxLevel >= 2;
	    incase 8:
		pLevel := &VigorMax;
	    incase 7:
		pLevel := &ShieldMax;
	    incase 6:
		pLevel := &CureMax;
	    default:
		pLevel := &ProtectMax[Temp];
	    esac;
	fi;
	gotOne := false;
	if isBool then
	    if canKnow and not pBool* then
		pBool* := true;
		gotOne := true;
	    fi;
	else
	    if pLevel* < maxLevel then
		pLevel* := pLevel* + 1;
		gotOne := true;
	    fi;
	fi;
	if gotOne then
	    if not SpellKnown then
		SpellKnown := true;
		beep();
	    fi;
	    V*.PText(48);
	fi;
    fi;
corp;

/*
 * poof - guess what.
 */

proc poof()void:

    V*.Print("Poof!");
corp;

/*
 * fizz - guess what.
 */

proc fizz()void:

    V*.Print("Fizzle!");
corp;

/*
 * levSp - cast a spell which affects a numeric value dependent
 *		on a level.
 */

proc levSp(*uint pTime; *ushort currLevel; *uint value;
		       ushort newLevel, factor)void:

    if newLevel >= currLevel* then
	if currLevel* < newLevel then
	    value* := value* - currLevel* * factor;
	    pTime* := 0;
	fi;
	if pTime* = 0 then
	    value* := value* + newLevel * factor;
	    currLevel* := newLevel;
	fi;
	pTime* := pTime* + SPELLTIME;
	poof();
    else
	fizz();
    fi;
corp;

/*
 * mHit1 - allow monster to hit if not paralyzed.
 */

proc mHit1()void:

    if Paralyzed and V*.Random(if LuckTime ~= 0 then 9 else 6 fi) = 0 then
	V*.PText(73);
	Paralyzed := false;
    fi;
    if not Paralyzed then
	V*.MHit();
    fi;
corp;

/*
 * sHit - hit monster with spell.
 */

proc sHit(ATTACK typ; uint amount; *char missMess)void:

    if V*.underAttack then
	V*.PHit(typ, amount, missMess, "The spell hits for ");
    else
	fizz();
    fi;
corp;

/*
 * gNum - get a number in a given range.
 */

proc gNum(*char prompt; ushort limit; ushort err)ushort:

    while
	Temp := V*.ReadNum(prompt);
	Temp > limit
    do
	V*.PText(err);
    od;
    Temp
corp;

/*
 * gLevel - get a level for the spell to be cast at.
 */

proc gLevel(ushort choice)ushort:

    gNum("Cast at what level? ", SpellMax[choice], 50)
corp;

/*
 * mCh - check for a monster, and poof or fizzle.
 */

proc mCh()bool:

    if V*.underAttack then
	poof();
	true
    else
	fizz();
	false
    fi
corp;

/*
 * hitCh - if the player is under attack and the monster can attack from
 *	   a distance, then let it attack after the spell is cast.
 */

proc hitCh()void:

    if V*.underAttack and V*.monsterData.m_type >= A_MISSILE then
	mHit1();
    fi;
corp;

/*
 * mSpell - actually do the effects of a magic spell.
 */

proc mSpell(ushort which, level)void:

    if MagicDisabled then
	fizz();
    else
	case which
	incase 10:
	    if mCh() then
		for At from A_PUNCTURE - 1 upto A_DISPELL - 1 do
		    if V*.monsterData.m_vulnerability[At] < WKFAC then
			V*.monsterData.m_vulnerability[At] := 0;
		    else
			V*.monsterData.m_vulnerability[At] :=
			    V*.monsterData.m_vulnerability[At] - WKFAC;
		    fi;
		od;
	    fi;
	incase 9:
	    Doubled := mCh();
	incase 8:
	    sHit(A_HARMLESS, level * HFAC, nil);
	incase 7:
	    levSp(&StrengthTime, &StrengthLevel, &V*.strength, level, STFAC);
	    V*.maxCarryWeight := calcCarry();
	incase 6:
	    levSp(&StealthTime, &StealthLevel, &WTemp, level, 1);
	default:
	    sHit(A_PUNCTURE + which, make(level, uint) * ATFAC,
		 "The spell misses!");
	esac;
    fi;
corp;

/*
 * magicSpell - throw a magic spell.
 */

proc magicSpell()void:
    ushort choice, level;

    WantNumber := true;
    magicList();
    choice := gNum("Cast which magic spell? ", Count, 49);
    if choice ~= 0 then
	choice := choice - 1;
	if SpellBool[choice] then
	    level := SpellMax[choice];
	else
	    level := gLevel(choice);
	fi;
	Temp := (level - 1) * COSTFAC + 1;
	if MagicPoints < Temp then
	    V*.PText(51);
	    level := 0;
	else
	    MagicPoints := MagicPoints - Temp;
	fi;
	if level ~= 0 then
	    mSpell(SpellNumber[choice], level);
	    hitCh();
	fi;
    fi;
    V*.GraphicsDown();
corp;

/*
 * locate - display the player's current location.
 */

proc locate()void:

    V*.PText(52);
    if V*.onGrid then
	V*.PText(V*.grid + 190);
	V*.PMess(", co-ordinates ");
	V*.PNumber(V*.gridLine + 1);
	V*.PMess(", ");
	V*.PNumber(V*.gridCol + 1);
    else
	V*.PText(make(V*.maze, uint) + 210);
	V*.PMess(", co-ordinates ");
	V*.PNumber(V*.mazeLine + 1);
	V*.PMess(", ");
	V*.PNumber(V*.mazeCol + 1);
    fi;
    V*.Pnl();
corp;

/*
 * cSpell - case for cleric spell affects.
 */

proc cSpell(ushort which, level)void:

    if MagicDisabled then
	fizz();
    else
	case which
	incase 11:
	    poof();
	    locate();
	incase 10:
	    LuckTime := LuckTime + SPELLTIME;
	    poof();
	incase 9:
	    Paralyzed := mCh();
	incase 8:
	    levSp(&VigorTime, &VigorLevel, &V*.hitPoints, level, VFAC);
	incase 7:
	    if ShieldLevel > level then
		fizz();
	    elif ShieldLevel = level then
		ShieldTime := ShieldTime + SPELLTIME;
		poof();
	    else
		ShieldTime := SPELLTIME;
		level := level - ShieldLevel;
		ShieldLevel := ShieldLevel + level;
		for At from A_PUNCTURE - 1 upto A_DISPELL - 1 do
		    V*.protection[At] := V*.protection[At] + level * SHFAC;
		od;
		poof();
	    fi;
	incase 6:
	    WTemp := level * CUREFAC;
	    if V*.health + WTemp > V*.hitPoints then
		V*.health := V*.hitPoints;
	    else
		V*.health := V*.health + WTemp;
	    fi;
	    poof();
	default:
	    levSp(&ProtectTime[which], &ProtectLevel[which],
		  &V*.protection[which], level, PRFAC);
	esac;
    fi;
corp;

/*
 * clericSpell - throw a cleric spell.
 */

proc clericSpell()void:
    ushort choice, level;

    WantNumber := true;
    clericList();
    choice := gNum("Cast which cleric spell? ", Count, 49);
    if choice ~= 0 then
	choice := choice - 1;
	if SpellBool[choice] then
	    level := SpellMax[choice];
	else
	    level := gLevel(choice);
	fi;
	Temp := (level - 1) * COSTFAC + 1;
	if ClericPoints < Temp then
	    V*.PText(51);
	    level := 0;
	else
	    ClericPoints := ClericPoints - Temp;
	fi;
	if level ~= 0 then
	    cSpell(SpellNumber[choice], level);
	    hitCh();
	fi;
    fi;
    V*.GraphicsDown();
corp;

/*
 * companion - a companion object is fighting.
 */

proc companion(OBJECT o; ATTACK a; *char missMess, hitMess)void:

    if V*.underAttack and V*.IsCarrying(o) and V*.weaponNumber ~= o then
	V*.PHit(a, COMPFAC, missMess, hitMess);
    fi;
corp;

/*
 * HACheck - check for companion hits.
 */

proc HACheck()void:

    companion(15, A_PUNCTURE, "The Magic Sword misses!",
	      "The Magic Sword hits (puncture) for ");
    companion(16, A_MISSILE, "The Enchanted Bow misses!",
	      "The Enchanted Bow hits (missile) for ");
    companion(17, A_SMASH, "Thor's Hammer misses!",
	      "Thor's Hammer hits (smash) for ");
    companion(18, A_HEAT, "The Ruby of Fire misses!",
	      "The Ruby of Fire hits (heat) for ");
    companion(19, A_CHILL, "The Diamond of Ice misses!",
	      "The Diamond of Ice hits (chill) for ");
    companion(20, A_DISPELL, "The Sacred Signet misses!",
	      "The Sacred Signet hits (dispell) for ");
    if OnHorse and V*.underAttack then
	V*.PHit(A_SMASH, COMPFAC / 2, "Pandora misses!",
	     "Pandora hits (smash) for ");
    fi;
corp;

/*
 * physHit - hit physically. (Used here and in AMELON1 (for .u))
 */

proc physHit(ATTACK a; uint str)void:

    pHit1(a, str);
    HACheck();
    if Doubled and V*.underAttack then
	pHit1(a, str);
	HACheck();
    fi;
corp;

/*
 * shield - use a shielding object.
 */

proc shield(ushort newOb, oldOb)void:

    Temp := V*.GetObject(newOb)*.ob_strength -
	    if oldOb = 255 then 0 else V*.GetObject(oldOb)*.ob_strength fi;
    for At from A_PUNCTURE - 1 upto A_MISSILE - 1 do
	V*.protection[At] := V*.protection[At] + Temp;
    od;
corp;

/*
 * use - the player is using some object:
 */

proc use(ushort o)void:
    *OBJECTTYPE op;
    bool mDis, Zont;

    case o
    incase 8 .. 10:
	shield(o, Shield);
	Shield := o;
    incase 0 .. 6:
    incase 11 .. 20:
	if V*.underAttack then
	    op := V*.GetObject(o);
	    physHit(op*.ob_type,
		    op*.ob_strength + op*.ob_strength*(V*.strength-10) / 50);
	else
	    V*.PText(10);
	fi;
    incase 21:
	mDis := MagicDisabled;
	MagicDisabled := V*.monsterNumber = 0;
	Zont := V*.underAttack and V*.monsterNumber = 97;
	mSpell(8, 4);
	if Zont and not V*.underAttack then
	    ZontallahDead := true;
	    V*.PText(72);
	fi;
	MagicDisabled := mDis;
    incase 22:
	V*.PText(108);
    incase 27 .. 29:
	shield(o, Armour);
	Armour := o;
    incase 30:
	if not SCOn then
	    SCOn := true;
	    V*.protection[A_DISPELL - 1] := V*.protection[A_DISPELL - 1] + 30;
	fi;
    incase 31:
	if not TROn then
	    TROn := true;
	    V*.protection[A_HEAT - 1] := V*.protection[A_HEAT - 1] + 30;
	    V*.protection[A_CHILL - 1] := V*.protection[A_CHILL - 1] + 30;
	fi;
    incase 35:
	V*.PText(90);
    incase 36:
	cSpell(6, 1);
    incase 37:
	mSpell(8, 1);
    incase 38:
	cSpell(10, 1);
    incase 39:
	cSpell(9, 1);
    incase 40:
	cSpell(7, 1);
    incase 41:
	mSpell(7, 1);
    incase 42:
	cSpell(8, 1);
    incase 43:
	mSpell(6, 1);
    incase 44:
	cSpell(11, 1);
    default:
	V*.PText(74);
    esac;
    op := V*.GetObject(o);
    if op*.ob_weakness ~= 0 and
	    V*.Random((0xff - op*.ob_weakness) * 4) = 0 then
	V*.PMess("The ");
	V*.PMess(getObName(o));
	V*.Print(" breaks!");
	beep();
	V*.Drop(o);
	if V*.armed and V*.weaponNumber = o then
	    V*.armed := false;
	fi;
    fi;
    mHit1();
corp;
