#drinc:exec/miscellaneous.g
#drinc:exec/memory.g
#drinc:libraries/dos.g
#/include/explore.g
#cre.g

extern
    err(*char message)void,
    ask(*char question)bool,
    fileMess(*char message)void,
    fileDestroy()void,
    fileOpen(bool isRead)bool,
    fileOpen2()void,
    fileClose()void,
    fileRead()byte,
    fileWrite(byte b)void,
    fileGet(*byte buff; uint length)void,
    filePut(*byte buff; uint length)void,
    fileName(*char name, defExt)void,
    fileType(*char typ)void,
    fileSave(*FILENAME pn)void,
    fileRestore(*FILENAME n)void,
    fileBackup(*char newExt)void,
    getLine(*char prompt)void,
    CAP()void,
    cmdWrd(*char command, choices)ushort,

    putChar(char ch)void,
    putString(*char st)void,
    newLine()void,
    printerOn()bool,
    printerOff()void;

/*
 * wldClr - creating a new world from scratch; initialize everything.
 */

proc wldClr()void:
    type PATTERNPLANE = [PATTERNMLINES] uint;
    *CYCLETYPE cy;
    uint i, j, k;

    NameNext := 0;
    GridNext := 0;
    MazeNext := 0;
    PatternNext := 8;
    PictureNext := 0;
    PolygonNext := 0;
    FullPaletteNext := 1;
    HalfPaletteNext := 1;
    VertexNext := 0;
    GridSpecialNext := 0;
    BitPosNext := 0;
    ObjectNext := 0;
    MonsterNext := 0;
    TerritoryNext := 0;
    FullPalette[0].fp_palette := FULLPALETTEARRAY(
	0x06d, /*  0 - dark blue */
	0x000, /*  1 - black */
	0x2c0, /*  2 - dark green */
	0xff0, /*  3 - lemon yellow */
	0x00f, /*  4 - blue */
	0xd00, /*  5 - brick red */
	0xf90, /*  6 - orange */
	0xc80, /*  7 - brown */
	0x91f, /*  8 - purple */
	0xfac, /*  9 - pink */
	0x6fe, /* 10 - sky blue */
	0xa87, /* 11 - dark brown */
	0x0bb, /* 12 - blue green */
	0x0f0, /* 13 - green */
	0xf9a, /* 14 - cherry red */
	0x0db, /* 15 - aqua */
	0xdb9, /* 16 - tan */
	0xfb0, /* 17 - golden orange */
	0xc1f, /* 18 - violet */
	0x0b1, /* 19 - forest green */
	0x6ce, /* 20 - light blue */
	0xf00, /* 21 - red */
	0xfff, /* 22 - unused 0 */
	0x000, /* 23 - black */
	0x222, /* 24 - darkest grey */
	0x444, /* 25 */
	0x666, /* 26 */
	0x888, /* 27 - medium grey */
	0xaaa, /* 28 */
	0xccc, /* 29 - light grey */
	0xeee, /* 30 - lightest grey */
	0xfff  /* 31 - white */
    );
    cy := &FullPalette[0].fp_cycles[0];
    for i from 0 upto 1 do
	cy*.cy_firstColour := 0;
	cy*.cy_lastColour := 0;
	cy*.cy_period := 0;
	cy := cy + sizeof(CYCLETYPE);
    od;
    HalfPalette[0].hp_palette := HALFPALETTEARRAY(
	0x2c0, /*  0 - dark green */
	0xff0, /*  1 - lemon yellow */
	0x00f, /*  2 - blue */
	0xd00, /*  3 - brick red */
	0xf90, /*  4 - orange */
	0xc80, /*  5 - brown */
	0x91f, /*  6 - purple */
	0x000, /*  7 - black */
	0xfff, /*  8 - white */
	0x0db, /*  9 - aqua */
	0xdb9, /* 10 - tan */
	0xfb0, /* 11 - golden orange */
	0xc1f, /* 12 - violet */
	0x0b1, /* 13 - forest green */
	0x6ce, /* 14 - light blue */
	0xf00  /* 15 - red */
    );
    cy := &HalfPalette[0].hp_cycles[0];
    for i from 0 upto 3 do
	cy*.cy_firstColour := 0;
	cy*.cy_lastColour := 0;
	cy*.cy_period := 0;
	cy := cy + sizeof(CYCLETYPE);
    od;
    if PATTERNMCOLS ~= 1 then
	error("PATTERNMCOLS ~= 1 in wldClr");
    fi;
    for i from 0 upto 7 do
	Pattern*[i].pa_topRound := false;
	Pattern*[i].pa_rightRound := false;
	Pattern*[i].pa_bottomRound := false;
	Pattern*[i].pa_leftRound := false;
	for j from 0 upto PATTERNDEPTH - 1 do
	    for k from 0 upto PATTERNLINES - 1 do
		Pattern*[i].pa_data[j, k, 0] := 0;
	    od;
	od;
    od;
    pretend(&Pattern*[0].pa_data[0, 0, 0], *PATTERNPLANE)* := PATTERNPLANE(
	0b0001000110000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000);
    pretend(&Pattern*[1].pa_data[0, 0, 0], *PATTERNPLANE)* := PATTERNPLANE(
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000001,
	0b0000000000000001,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000);
    pretend(&Pattern*[2].pa_data[0, 0, 0], *PATTERNPLANE)* := PATTERNPLANE(
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000010000011000);
    pretend(&Pattern*[3].pa_data[0, 0, 0], *PATTERNPLANE)* := PATTERNPLANE(
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b1000000000000000,
	0b1000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b1000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000);
    pretend(&Pattern*[4].pa_data[0, 0, 0], *PATTERNPLANE)* := PATTERNPLANE(
	0b0000000000000001,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000);
    pretend(&Pattern*[5].pa_data[0, 0, 0], *PATTERNPLANE)* := PATTERNPLANE(
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000001,
	0b0000000000000011,
	0b0000000000001111);
    pretend(&Pattern*[6].pa_data[0, 0, 0], *PATTERNPLANE)* := PATTERNPLANE(
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b1000000000000000,
	0b1000000000000000,
	0b1100000000000000);
    pretend(&Pattern*[7].pa_data[0, 0, 0], *PATTERNPLANE)* := PATTERNPLANE(
	0b1110000000000000,
	0b1100000000000000,
	0b1000000000000000,
	0b1000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000,
	0b0000000000000000);
corp;

/*
 * putInt - output an integer.
 */

proc putInt(int n)void:
    [6] char buffer;
    *char p;

    if n < 0 then
	putChar('-');
	n := - n;
    fi;
    buffer[5] := '\e';
    p := &buffer[4];
    while
	p* := n % 10 + '0';
	n := n / 10;
	n ~= 0
    do
	p := p - 1;
    od;
    putString(p);
corp;

/*
 * pairDis - display a current/maximum pair.
 */

proc pairDis(uint cur, max; *char what)void:

    putString("\n    ");
    putInt(cur);
    putChar('/');
    putInt(max);
    putChar(' ');
    putString(what);
corp;

/*
 * wldDis - display the status of the current world.
 */

proc wldDis()void:

    newLine();
    putString("World file ");
    fileMess("");
    pairDis(GridNext, GRIDMAX, "grids");
    pairDis(GridSpecialNext, GRIDSPECIALMAX, "special terrain entries");
    pairDis(TerritoryNext, TERRITORYMAX, "territory types");
    pairDis(PatternNext, PATTERNMAX, "patterns");
    pairDis(MazeNext, MAZEMAX, "mazes");
    pairDis(PictureNext, PICTUREMAX, "pictures");
    pairDis(PolygonNext, POLYGONMAX, "picture polygons");
    pairDis(VertexNext, VERTEXMAX, "picture vertexes");
    pairDis(FullPaletteNext, FULLPALETTEMAX, "full palettes");
    pairDis(HalfPaletteNext, HALFPALETTEMAX, "half palettes");
    pairDis(ObjectNext, OBJECTMAX, "object types");
    pairDis(MonsterNext, MONSTERMAX, "monster types");
    pairDis(NameNext, NAMEMAX, "characters in names");
    pairDis(BitPosNext, BITPOSMAX, "bytes of grid/maze data");
    newLine();
    newLine();
corp;

/*
 * worldHelp - print instructions for world editing.
 */

proc worldHelp()void:

    putString(
	"Commands are:\n\n"
	"\t?, Help - display this help information\n"
	"\tEXit, STOp - exit and update world file\n"
	"\tQuit - exit without updating world file\n"
	"\tPrint ON/OFf - enable/disable printer echo\n"
	"\tSTAtus, World - display information about this world\n"
	"\tMenu - display pattern menu\n"
	"\tDUmp All/Grid/MAze/Territory/Object/MOnster\n"
	"\tCreate/EDit/DElete Grid/MAze/PATtern/PIcture/\n"
	"\t\t\t   Territory/Object/MOnster/Half/Full [\#]\n"
	"\tDIsplay Territory/Object/MOnster/grid-Special [\#]\n"
	"\tSCan PAttern/PIcture/Territory/MOnster/Half/Full [\#]\n"
	"\n"
    );
corp;

/*
 * dump - dump out all objects, monsters, territories and mazes.
 */

proc dump(ushort what)void:
    extern
	obPr(OBJECT o)void,
	monPr(MONSTER m)void,
	terPr(TERRITORY t)void,
	gridPrint(GRID g)void,
	mazePrint(MAZE m)void;
    OBJECT o;
    MONSTER mo;
    TERRITORY t;
    MAZE ma;
    GRID g;

    if what = 0 or what = 1 then
	for o from 1 upto ObjectNext do
	    obPr(o - 1);
	od;
    fi;
    if what = 0 or what = 2 then
	for mo from 1 upto MonsterNext do
	    monPr(mo - 1);
	od;
    fi;
    if what = 0 or what = 3 then
	for t from 1 upto TerritoryNext do
	    terPr(t - 1);
	od;
    fi;
    if what = 0 or what = 4 then
	for ma from 1 upto MazeNext do
	    mazePrint(ma - 1);
	od;
    fi;
    if what = 0 or what = 5 then
	for g from 1 upto GridNext do
	    gridPrint(g - 1);
	od;
    fi;
corp;

/*
 * getWldCmd - read and parse a command for world editing.
 */

proc getWldCmd(*ushort pVerb, pNoun)void:
    *char w1, w2, p;

    getLine("WORLD> ");
    CAP();
    p := &Buffer[0];
    w1 := p;
    while p* ~= ' ' and p* ~= '\e' do
	p := p + 1;
    od;
    if p* = '\e' then
	w2 := p;
	Number := p;
    else
	p* := '\e';
	p := p + 1;
	while p* = ' ' do
	    p := p + 1;
	od;
	w2 := p;
	while p* ~= ' ' and p* ~= '\e' do
	    p := p + 1;
	od;
	if p* = '\e' then
	    Number := p;
	else
	    p* := '\e';
	    p := p + 1;
	    while p* = ' ' do
		p := p + 1;
	    od;
	    Number := p;
	    while p* ~= ' ' and p* ~= '\e' do
		p := p + 1;
	    od;
	    p* := '\e';
	fi;
    fi;
    pVerb* := cmdWrd(w1,
	"QUIT\eEXIT\eSTOP\e?\eHELP\e\PRINT\eSTATUS\eWORLD\eMENU\eDUMP\e"
	"CREATE\eEDIT\eDELETE\eDISPLAY\eSCAN\e\e");
    pNoun* := cmdWrd(w2,
	"GRID\ePATTERN\eMAZE\ePICTURE\eOBJECT\eMONSTER\eTERRITORY\e"
	"ALL\eON\eOFF\eSPECIAL\eHALF\eFULL\e\e");
corp;

/*
 * wldCmds - get and execute world creation commands.
 *	Return 'true' if we want to update the world file.
 */

proc wldCmds()bool:
    extern
	obCre()void,
	obEd()void,
	obDel()void,
	obDis()void,
	monCre()void,
	monEd()void,
	monDel()void,
	monDis()void,
	monScan()void,
	terCre()void,
	terEd()void,
	terDel()void,
	terDis()void,
	terScan()void,
	gridCreate()void,
	gridEdit()void,
	gridDelete()void,
	gridPatternMenu()void,
	patternCreate()void,
	patternEdit()void,
	patternDelete()void,
	patScan()void,
	mazeCreate()void,
	mazeEdit()void,
	mazeDelete()void,
	pictureCreate()void,
	pictureEdit()void,
	pictureDelete()void,
	pictureScan()void,
	gspDis()void,
	paletteCreate(bool isHalf)void,
	paletteEdit(bool isHalf)void,
	paletteDelete(bool isHalf)void,
	paletteScan(bool isHalf)void;
    uint i, j, k;
    ushort verb, noun;

    LastFullPalette := 0;
    LastHalfPalette := 0;
    k := 8;
    for i from 0 upto 2 do
	for j from 0 upto 7 do
	    if PatternNext = 8 then
		BackGroundPattern[i, j] := 8;
	    else
		BackGroundPattern[i, j] := k;
		k := k + 1;
		if k = PatternNext then
		    k := 8;
		fi;
	    fi;
	od;
    od;
    while
	getWldCmd(&verb, &noun);
	if verb = 1 then
	    not ask("Quit without saving? ")
	else
	    verb ~= 2 and verb ~= 3
	fi
    do
	case verb
	incase 1:
	    ;
	incase 4:
	incase 5:
	    worldHelp();
	incase 6:
	    if noun = 9 then
		if Printing then
		    err("Already printing");
		else
		    Printing := printerOn();
		fi;
	    elif noun = 10 then
		if Printing then
		    Printing := false;
		    printerOff();
		else
		    err("Not currently printing");
		fi;
	    else
		err("Invalid command; ? for help");
	    fi;
	incase 7:
	incase 8:
	    wldDis();
	incase 9:
	    gridPatternMenu();
	incase 10:
	    if noun = 0 or noun = 2 or noun = 4 or noun >= 9 then
		err("Invalid dump command; ? for help");
	    else
		dump(
		    case noun
		    incase 8:
			0
		    incase 5:
			1
		    incase 6:
			2
		    incase 7:
			3
		    incase 3:
			4
		    incase 1:
			5
		    default:
			0
		    esac);
	    fi;
	incase 11:
	    case noun
	    incase 1:
		gridCreate();
	    incase 2:
		patternCreate();
	    incase 3:
		mazeCreate();
	    incase 4:
		pictureCreate();
	    incase 5:
		obCre();
	    incase 6:
		monCre();
	    incase 7:
		terCre();
	    incase 12:
		paletteCreate(true);
	    incase 13:
		paletteCreate(false);
	    default:
		err("Invalid create command; ? for help");
	    esac;
	incase 12:
	    case noun
	    incase 1:
		gridEdit();
	    incase 2:
		patternEdit();
	    incase 3:
		mazeEdit();
	    incase 4:
		pictureEdit();
	    incase 5:
		obEd();
	    incase 6:
		monEd();
	    incase 7:
		terEd();
	    incase 12:
		paletteEdit(true);
	    incase 13:
		paletteEdit(false);
	    default:
		err("Invalid edit command; ? for help");
	    esac;
	incase 13:
	    case noun
	    incase 1:
		gridDelete();
	    incase 2:
		patternDelete();
	    incase 3:
		mazeDelete();
	    incase 4:
		pictureDelete();
	    incase 5:
		obDel();
	    incase 6:
		monDel();
	    incase 7:
		terDel();
	    incase 12:
		paletteDelete(true);
	    incase 13:
		paletteDelete(false);
	    default:
		err("Invalid delete command; ? for help");
	    esac;
	incase 14:
	    case noun
	    incase 5:
		obDis();
	    incase 6:
		monDis();
	    incase 7:
		terDis();
	    incase 11:
		gspDis();
	    default:
		err("Invalid display command; ? for help");
	    esac;
	incase 15:
	    case noun
	    incase 2:
		patScan();
	    incase 4:
		pictureScan();
	    incase 6:
		monScan();
	    incase 7:
		terScan();
	    incase 12:
		paletteScan(true);
	    incase 13:
		paletteScan(false);
	    default:
		err("Invalid scan command; ? for help");
	    esac;
	default:
	    err("Invalid command; ? for help");
	esac;
    od;
    verb ~= 1
corp;

/*
 * worldGet - read in the entire world.
 */

proc worldGet()void:

    fileGet(pretend(&NameNext, *byte), sizeof(uint));
    fileGet(pretend(&Name[0], *byte), sizeof(char) * NameNext);
    fileGet(pretend(&GridNext, *byte), sizeof(GRID));
    fileGet(pretend(&Grid[0], *byte),
	      sizeof(GRIDTYPE) * make(GridNext, uint));
    fileGet(pretend(&GridSpecialNext, *byte), sizeof(GRIDSPECIAL));
    fileGet(pretend(&GridSpecial[0], *byte),
	      sizeof(GRIDSPECIALTYPE) * make(GridSpecialNext, uint));
    fileGet(pretend(&TerritoryNext, *byte), sizeof(TERRITORY));
    fileGet(pretend(&Territory[0], *byte),
	      sizeof(TERRITORYTYPE) * make(TerritoryNext, uint));
    fileGet(pretend(&PatternNext, *byte), sizeof(PATTERN));
    fileGet(pretend(&Pattern*[0], *byte),
	      sizeof(PATTERNTYPE) * make(PatternNext, uint));
    fileGet(pretend(&MazeNext, *byte), sizeof(MAZE));
    fileGet(pretend(&Maze[0], *byte),
	      sizeof(MAZETYPE) * make(MazeNext, uint));
    fileGet(pretend(&PictureNext, *byte), sizeof(PICTURE));
    fileGet(pretend(&Picture[0], *byte),
	      sizeof(PICTURETYPE) * make(PictureNext, uint));
    fileGet(pretend(&PolygonNext, *byte), sizeof(POLYGON));
    fileGet(pretend(&Polygon[0], *byte),
	      sizeof(POLYGONTYPE) * make(PolygonNext, uint));
    fileGet(pretend(&VertexNext, *byte), sizeof(VERTEX));
    fileGet(pretend(&Vertex[0], *byte),
	      sizeof(VERTEXTYPE) * make(VertexNext, uint));
    fileGet(pretend(&ObjectNext, *byte), sizeof(OBJECT));
    fileGet(pretend(&Object[0], *byte),
	      sizeof(OBJECTTYPE) * make(ObjectNext, uint));
    fileGet(pretend(&MonsterNext, *byte), sizeof(MONSTER));
    fileGet(pretend(&Monster[0], *byte),
	      sizeof(MONSTERTYPE) * make(MonsterNext, uint));
    fileGet(pretend(&FullPaletteNext, *byte), sizeof(FULLPALETTE));
    fileGet(pretend(&FullPalette[0], *byte),
	      sizeof(FULLPALETTETYPE) * make(FullPaletteNext, uint));
    fileGet(pretend(&HalfPaletteNext, *byte), sizeof(HALFPALETTE));
    fileGet(pretend(&HalfPalette[0], *byte),
	      sizeof(HALFPALETTETYPE) * make(HalfPaletteNext, uint));
    fileGet(pretend(&BitPosNext, *byte), sizeof(BITPOS));
    fileGet(pretend(&BitRaw[0], *byte), BitPosNext);
corp;

/*
 * worldPut - put the entire world out to the file.
 */

proc worldPut()void:

    filePut(pretend(&NameNext, *byte), sizeof(uint));
    filePut(pretend(&Name[0], *byte), sizeof(char) * NameNext);
    filePut(pretend(&GridNext, *byte), sizeof(GRID));
    filePut(pretend(&Grid[0], *byte),
	       sizeof(GRIDTYPE) * make(GridNext, uint));
    filePut(pretend(&GridSpecialNext, *byte), sizeof(GRIDSPECIAL));
    filePut(pretend(&GridSpecial[0], *byte),
	       sizeof(GRIDSPECIALTYPE) * make(GridSpecialNext, uint));
    filePut(pretend(&TerritoryNext, *byte), sizeof(TERRITORY));
    filePut(pretend(&Territory[0], *byte),
	       sizeof(TERRITORYTYPE) * make(TerritoryNext, uint));
    filePut(pretend(&PatternNext, *byte), sizeof(PATTERN));
    filePut(pretend(&Pattern*[0], *byte),
	       sizeof(PATTERNTYPE) * make(PatternNext, uint));
    filePut(pretend(&MazeNext, *byte), sizeof(MAZE));
    filePut(pretend(&Maze[0], *byte),
	       sizeof(MAZETYPE) * make(MazeNext, uint));
    filePut(pretend(&PictureNext, *byte), sizeof(PICTURE));
    filePut(pretend(&Picture[0], *byte),
	       sizeof(PICTURETYPE) * make(PictureNext, uint));
    filePut(pretend(&PolygonNext, *byte), sizeof(POLYGON));
    filePut(pretend(&Polygon[0], *byte),
	       sizeof(POLYGONTYPE) * make(PolygonNext, uint));
    filePut(pretend(&VertexNext, *byte), sizeof(VERTEX));
    filePut(pretend(&Vertex[0], *byte),
	       sizeof(VERTEXTYPE) * make(VertexNext, uint));
    filePut(pretend(&ObjectNext, *byte), sizeof(OBJECT));
    filePut(pretend(&Object[0], *byte),
	       sizeof(OBJECTTYPE) * make(ObjectNext, uint));
    filePut(pretend(&MonsterNext, *byte), sizeof(MONSTER));
    filePut(pretend(&Monster[0], *byte),
	       sizeof(MONSTERTYPE) * make(MonsterNext, uint));
    filePut(pretend(&FullPaletteNext, *byte), sizeof(FULLPALETTE));
    filePut(pretend(&FullPalette[0], *byte),
	      sizeof(FULLPALETTETYPE) * make(FullPaletteNext, uint));
    filePut(pretend(&HalfPaletteNext, *byte), sizeof(HALFPALETTE));
    filePut(pretend(&HalfPalette[0], *byte),
	      sizeof(HALFPALETTETYPE) * make(HalfPaletteNext, uint));
    filePut(pretend(&BitPosNext, *byte), sizeof(BITPOS));
    filePut(pretend(&BitRaw[0], *byte), BitPosNext);
corp;

/*
 * main - handle parameters (world name)
 */

proc main()void:
    extern
	GetPars(*ulong pLen; **char pP)void,
	amigaInit()bool,
	amigaTerm()void;
    *char p, q;
    ulong len, fd;
    FILENAME saveName;
    bool isNew;

    if OpenDosLibrary(0) ~= nil then
	fd := Output();
	Printing := false;
	Editing := false;
	GetPars(&len, &p);
	while p* = ' ' do
	    p := p + 1;
	od;
	if p* = '\n' or p* = '\r' or p* = '\e' then
	    pretend(Write(fd, pretend("Use is: expcre file[.wld]\n", *byte),
			  26), void);
	else
	    Pattern := nil;
	    if OpenExecLibrary(0) ~= nil then
		Pattern :=
		    pretend(AllocMem(PATTERNMAX * sizeof(PATTERNTYPE),
				     MEMF_CHIP),
			    *[PATTERNMAX] PATTERNTYPE);
		if Pattern ~= nil and amigaInit() then
		    q := &saveName[0];
		    while p* ~= '\r' and p* ~= '\n' and p* ~= '\e' do
			q* := p*;
			q := q + 1;
			p := p + 1;
		    od;
		    q* := '\e';
		    fileName(&saveName[0], "wld");
		    isNew :=
			if fileOpen(true) then
			    worldGet();
			    fileClose();
			    false
			else
			    wldClr();
			    true
			fi;
		    fileSave(&saveName);
		    if wldCmds() then
			fileRestore(&saveName);
			if not isNew then
			    fileType("old");
			    fileDestroy();
			    fileType("wld");
			    fileBackup("old");
			fi;
			fileOpen2();
			worldPut();
			fileClose();
			p := &saveName[0];
			while p* ~= '\e' do
			    p := p + 1;
			od;
			pretend(
			    Write(fd,
				pretend(&saveName[0], *byte),
				p-&saveName[0]),
			    void);
			pretend(
			    Write(fd,
				pretend(": world file updated.\n", *byte),
				22),
			    void);
		    fi;
		    amigaTerm();
		else
		    pretend(Write(fd,
		     pretend("*** Amiga specific initialization failed! ***\n",
			     *byte), 46), void);
		fi;
		if Pattern ~= nil then
		    FreeMem(pretend(Pattern, *byte),
			    PATTERNMAX * sizeof(PATTERNTYPE));
		fi;
		CloseExecLibrary();
	    fi;
	fi;
	CloseDosLibrary();
    fi;
corp;
