#/include/explore.g
#cre.g

extern
    putString(*char message)void,
    putInt(uint n)void,
    newLine()void,
    gL1(*char prompt)bool,
    getLine(*char prompt)void,
    CAP()void,
    cmdWrd(*char inp, words)ushort,
    err(*char mess)void,
    getNumber(*int pn; *char prompt; int minV, maxV; bool inCmd)bool,
    getNum(*char prompt; int minV, maxV)int,
    repNum(*char prompt; int minV, maxV, oldV)int,
    scan(*char n1, n2; *ushort p; ushort x, cnt, size)ushort,
    decr(*ushort p; ushort x, cnt, size)void,
    wordDecr(*uint p; uint x, amnt, cnt, size)void,
    noOb()void,
    noMon()void,
    noTer()void,
    noPat()void,
    noPic()void;

/*
 * printName - print out a monster/object name.
 */

proc printName(uint name)void:

    putString(&Name[name]);
corp;

/*
 * nameDel - delete a name if no-one else references it.
 */

proc nameDel(uint name)void:
    *char p, q;
    MONSTER m;
    OBJECT o;
    ushort useCount;

    useCount := 0;
    for m from 1 upto MonsterNext do
	if Monster[m - 1].m_name = name then
	    useCount := useCount + 1;
	fi;
    od;
    for o from 1 upto ObjectNext do
	if Object[o - 1].ob_name = name then
	    useCount := useCount + 1;
	fi;
    od;
    if useCount = 1 then
	p := &Name[name];
	q := p;
	while p* ~= '\e' do
	    p := p + 1;
	od;
	p := p + 1;
	while p ~= &Name[NameNext] do
	    q* := p*;
	    q := q + 1;
	    p := p + 1;
	od;
	NameNext := NameNext - (p - q);
	wordDecr(&Monster[0].m_name, name, (p - q),
		 MonsterNext, sizeof(MONSTERTYPE));
	wordDecr(&Object[0].ob_name, name, (p - q),
		 ObjectNext, sizeof(OBJECTTYPE));
    fi;
corp;

/*
 * nameGet - get a name for an object or monster type.
 */

proc nameGet(*char prompt; *uint pVal)void:
    uint pos, res;
    *char p;

    if
	if Editing then
	    putString(prompt);
	    printName(pVal*);
	    newLine();
	    if gL1(prompt) then
		nameDel(pVal*);
		true
	    else
		false
	    fi
	else
	    getLine(prompt);
	    true
	fi
    then
	pos := 0;
	while
	    p := &Buffer[0];
	    res := pos;
	    if pos = NameNext then
		while
		    if NameNext = NAMEMAX then
			err("Name buffer overflow");
			if res = NAMEMAX then
			    res := 0;
			else
			    Name[NAMEMAX - 1] := '\e';
			fi;
		    else
			Name[NameNext] := p*;
			NameNext := NameNext + 1;
		    fi;
		    p* ~= '\e'
		do
		    p := p + 1;
		od;
		false
	    else
		while p* ~= '\e' and p* = Name[pos] do
		    p := p + 1;
		    pos := pos + 1;
		od;
		if p* = Name[pos] then
		    false
		else
		    while Name[pos] ~= '\e' do
			pos := pos + 1;
		    od;
		    pos := pos + 1;
		    true
		fi
	    fi
	do
	od;
	pVal* := res;
    fi;
corp;

/*
 * getAttTyp - return the string for an attack type.
 */

proc getAttTyp(ATTACK a)*char:

    case a
    incase A_HARMLESS:
	"Harmless"
    incase A_PUNCTURE:
	"Puncture"
    incase A_SMASH:
	"Smash"
    incase A_MISSILE:
	"Missile"
    incase A_HEAT:
	"Heat"
    incase A_CHILL:
	"Chill"
    incase A_DISPELL:
	"Dispell"
    esac
corp;

/*
 * prAtt - print out an attack type.
 */

proc prAtt(ATTACK a)void:

    putString(getAttTyp(a));
corp;

/*
 * getAtt - get an attack type for an object or monster.
 */

proc getAtt(*ATTACK pAtt)void:
    ATTACK a;

    if Editing then
	putString("Attack type: ");
	prAtt(pAtt*);
	newLine();
    fi;
    while
	if
	    if Editing then
		gL1("Attack type: ")
	    else
		getLine("Attack type: ");
		true
	    fi
	then
	    CAP();
	    a := A_HARMLESS + cmdWrd(&Buffer[0],
		"HARMLESS\ePUNCTURE\eSMASH\eMISSILE\e"
		"HEAT\eCHILL\eDISPELL\e\e");
	    if a = A_HARMLESS then
		true
	    else
		pAtt* := a - 1;
		false
	    fi
	else
	    false
	fi
    do
	putString("*** Unknown attack type, valid attack types are:\n    "
	       "Harmless, Puncture, Smash, Missile, Heat, Chill and "
	       "Dispell\n");
    od;
corp;

/*
 * obEnt - enter the specifications for an object.
 */

proc obEnt(OBJECT o)void:
    *OBJECTTYPE ob;

    ob := &Object[o];
    nameGet("Name of object type: ", &ob*.ob_name);
    getAtt(&ob*.ob_type);
    ob*.ob_strength :=
	repNum("Attack strength (0-255): ", 0, 255, ob*.ob_strength);
    ob*.ob_weight :=
	repNum("Object weight (0-255): ", 0, 255, ob*.ob_weight);
    ob*.ob_weakness :=
	repNum("Object weakness (0-255): ", 0, 255, ob*.ob_weakness);
corp;

/*
 * obCre - create a new object type.
 */

proc obCre()void:

    if ObjectNext = OBJECTMAX then
	err("Too many objects");
    else
	putString("You are creating object type \#");
	putInt(ObjectNext);
	putString(".\n");
	obEnt(ObjectNext);
	ObjectNext := ObjectNext + 1;
    fi;
corp;

/*
 * obEd - edit an existing object type.
 */

proc obEd()void:
    int n;

    if ObjectNext = 0 then
	noOb();
    elif getNumber(&n, "Edit which object? ", 0, ObjectNext - 1, true) then
	Editing := true;
	obEnt(n);
	Editing := false;
    fi;
corp;

/*
 * obPr - print info for an object.
 */

proc obPr(OBJECT o)void:
    *OBJECTTYPE ob;

    ob := &Object[o];
    putString("\nObject \#");
    putInt(o);
    putString(":\n\n\tName: ");
    printName(ob*.ob_name);
    putString("\n\tAttack type: ");
    prAtt(ob*.ob_type);
    putString("\n\tAttack strength: ");
    putInt(ob*.ob_strength);
    putString("\n\tWeight: ");
    putInt(ob*.ob_weight);
    putString("\n\tWeakness: ");
    putInt(ob*.ob_weakness);
    putString("\n\n");
corp;

/*
 * obDis - display an existing object type.
 */

proc obDis()void:
    int n;

    if ObjectNext = 0 then
	noOb();
    elif getNumber(&n, "Display which object? ", 0, ObjectNext - 1,true) then
	obPr(n);
    fi;
corp;

/*
 * obDel - delete the selected object.
 */

proc obDel()void:
    int n;
    OBJECT o;

    if ObjectNext = 0 then
	noOb();
    elif getNumber(&n, "Delete which object? ", 0, ObjectNext - 1, true) then
	o := n;
	nameDel(Object[o].ob_name);
	ObjectNext := ObjectNext - 1;
	while o ~= ObjectNext do
	    Object[o] := Object[o + 1];
	    o := o + 1;
	od;
	putString("Object deleted.\n");
    fi;
corp;

/*
 * repVuln - replace a vulnerability.
 */

proc repVuln(*MONSTERTYPE mo; ATTACK a)void:
    *char prompt, p, which;

    prompt := "Vulnerability to xxxxxxxx (-128 - 127): ";
    which := getAttTyp(a);
    p := prompt + 17;
    while which* ~= '\e' do
	p* := which*;
	p := p + 1;
	which := which + 1;
    od;
    which := " (-128 - 127): ";
    while
	p* := which*;
	which* ~= '\e'
    do
	p := p + 1;
	which := which + 1;
    od;
    mo*.m_vulnerability[a - 1] :=
	repNum(prompt, -128, 127, mo*.m_vulnerability[a - 1]);
corp;

/*
 * monEnt - enter the data for a monster type.
 */

proc monEnt(MONSTER m)void:
    *MONSTERTYPE mo;

    mo := &Monster[m];
    nameGet("Enter name for monster type: ", &mo*.m_name);
    mo*.m_pattern :=
	repNum("Pattern for monster: ", 8, PatternNext - 1, mo*.m_pattern);
    mo*.m_picture :=
	repNum("Picture for monster: ", 0, PictureNext - 1, mo*.m_picture);
    mo*.m_palette :=
	repNum("Palette for monster: ", 0, HalfPaletteNext - 1, mo*.m_palette);
    mo*.m_image :=
	repNum("Image for monster: ", 0, 32767, mo*.m_image);
    getAtt(&mo*.m_type);
    mo*.m_strength :=
	repNum("Attack strength (0-255): ", 0, 255, mo*.m_strength);
    mo*.m_hitPoints :=
	repNum("Hit points (0-255): ", 0, 255, mo*.m_hitPoints);
    mo*.m_speed :=
	repNum("Speed (0-255): ", 0, 255, mo*.m_speed);
    repVuln(mo, A_PUNCTURE);
    repVuln(mo, A_SMASH);
    repVuln(mo, A_MISSILE);
    repVuln(mo, A_HEAT);
    repVuln(mo, A_CHILL);
    repVuln(mo, A_DISPELL);
corp;

/*
 * monCre - create a new monster type.
 */

proc monCre()void:

    if MonsterNext = MONSTERMAX then
	err("Too many monsters");
    elif PatternNext = 8 then
	noPat();
    elif PictureNext = 0 then
	noPic();
    else
	putString("You are creating monster type \#");
	putInt(MonsterNext);
	putString(".\n");
	monEnt(MonsterNext);
	MonsterNext := MonsterNext + 1;
    fi;
corp;

/*
 * monEd - edit an existing monster type.
 */

proc monEd()void:
    int n;

    if MonsterNext = 0 then
	noMon();
    elif getNumber(&n, "Edit which monster? ", 0, MonsterNext - 1, true) then
	Editing := true;
	monEnt(n);
	Editing := false;
    fi;
corp;

/*
 * monPr - print the info for the given monster.
 */

proc monPr(MONSTER m)void:
    *MONSTERTYPE mo;
    ATTACK a;

    mo := &Monster[m];
    putString("\nMonster \#");
    putInt(m);
    putString(":\n\n\tName: ");
    printName(mo*.m_name);
    putString("[");
    putInt((make(mo*.m_hitPoints, uint) + mo*.m_strength) / 50);
    putString("]\n\tDisplay pattern: \#");
    putInt(mo*.m_pattern);
    putString("\n\tMaze picture: \#");
    putInt(mo*.m_picture);
    putString("\n\tUsing half palette: \#");
    putInt(mo*.m_palette);
    putString("\n\tMaze image: \#");
    putInt(mo*.m_image);
    putString("\n\tAttack type: ");
    prAtt(mo*.m_type);
    putString("\n\tAttack strength: ");
    putInt(mo*.m_strength);
    putString("\n\tHit points: ");
    putInt(mo*.m_hitPoints);
    putString("\n\tSpeed: ");
    putInt(mo*.m_speed);
    for a from A_PUNCTURE upto A_DISPELL do
	putString("\n\tVulnerability to ");
	prAtt(a);
	putString(": ");
	putInt(mo*.m_vulnerability[a - 1]);
    od;
    putString("\n\n");
corp;

/*
 * monDis - display the selected monster's properties.
 */

proc monDis()void:
    int n;

    if MonsterNext = 0 then
	noMon();
    elif getNumber(&n, "Display which monster? ",0,MonsterNext - 1,true) then
	monPr(n);
    fi;
corp;

/*
 * monChk - check if a monster is an occupant.
 */

proc monChk(*char n; *ushort p; ushort x, cnt, size)ushort:
    ushort i, found;

    found := 0;
    for i from 0 upto OCCUPANTCOUNT - 1 do
	if scan("Monster", n, p, x, cnt, size) ~= 0 then
	    found := 1;
	fi;
	p := p + sizeof(OCCUPANTTYPE);
    od;
    found
corp;

/*
 * monScn1 - scan all uses of this monster. Return true if it's used.
 */

proc monScn1(MONSTER m)bool:

    monChk("territory",
	   pretend(&Territory[0].t_occupants[0].oc_type, *ushort),
	   m, TerritoryNext, sizeof(TERRITORYTYPE)) |
    monChk("maze",
	   pretend(&Maze[0].ma_occupants[0].oc_type, *ushort),
	   m, MazeNext, sizeof(MAZETYPE)) ~= 0
corp;

/*
 * monDecr - fix up all occupants.
 */

proc monDecr(*ushort p; ushort x, cnt, size)void:
    ushort i;

    for i from 0 upto OCCUPANTCOUNT - 1 do
	decr(p, x, cnt, size);
	p := p + sizeof(OCCUPANTTYPE);
    od;
corp;

/*
 * monDel - delete a selected monster.
 */

proc monDel()void:
    int n;
    MONSTER m;

    if MonsterNext = 0 then
	noMon();
    elif getNumber(&n, "Delete which monster? ", 0,MonsterNext - 1,true) then
	m := n;
	if not monScn1(m) then
	    nameDel(Monster[m].m_name);
	    monDecr(pretend(&Territory[0].t_occupants[0].oc_type, *ushort),
		    m, TerritoryNext, sizeof(TERRITORYTYPE));
	    monDecr(pretend(&Maze[0].ma_occupants[0].oc_type, *ushort),
		    m, MazeNext, sizeof(MAZETYPE));
	    MonsterNext := MonsterNext - 1;
	    while m ~= MonsterNext do
		Monster[m] := Monster[m + 1];
		m := m + 1;
	    od;
	    putString("Monster deleted.\n");
	fi;
    fi;
corp;

/*
 * monScan - scan all monsters to see where they are used.
 */

proc monScan()void:
    int n;
    MONSTER m;

    if MonsterNext = 0 then
	noMon();
    elif Number* ~= '\e' then
	if getNumber(&n, "Scan which monster? ",0,MonsterNext - 1,true) then
	    pretend(monScn1(n), void);
	fi;
    else
	m := 0;
	while m ~= MonsterNext do
	    pretend(monScn1(m), void);
	    m := m + 1;
	od;
    fi;
corp;

/*
 * getMon - get (or replace) the monster set of a territory or maze.
 */

proc getMon(*OCCUPANTTYPE oc)void:
    *char prompt1, prompt2;
    ushort i;

    prompt1 := "Enter monster type of occupant \#X: ";
    prompt2 := "Enter probability for monster type \#X (0-255): ";
    for i from 0 upto OCCUPANTCOUNT - 1 do
	(prompt1 + 32)* := '1' + i;
	(prompt2 + 36)* := '1' + i;
	oc*.oc_type := repNum(prompt1, 0, MonsterNext - 1, oc*.oc_type);
	oc*.oc_probability := repNum(prompt2, 0, 255, oc*.oc_probability);
	oc := oc + sizeof(OCCUPANTTYPE);
    od;
corp;

/*
 * terEnt - enter the data for a territory type.
 */

proc terEnt(TERRITORY t)void:

    Territory[t].t_pattern :=
       repNum("Enter pattern for this territory: ", 8,
	      PatternNext - 1, Territory[t].t_pattern);
    getMon(&Territory[t].t_occupants[0]);
corp;

/*
 * terCre - create a new territory type.
 */

proc terCre()void:

    if TerritoryNext = TERRITORYMAX then
	err("Too many territorys");
    elif PatternNext = 8 then
	noPat();
    elif MonsterNext = 0 then
	noMon();
    else
	putString("You are creating territory type \#");
	putInt(TerritoryNext);
	putString(".\n");
	terEnt(TerritoryNext);
	TerritoryNext := TerritoryNext + 1;
    fi;
corp;

/*
 * terEd - edit an existing territory type.
 */

proc terEd()void:
    int n;

    if TerritoryNext = 0 then
	noTer();
    elif getNumber(&n,"Edit which territory? ",0,TerritoryNext - 1,true) then
	Editing := true;
	terEnt(n);
	Editing := false;
    fi;
corp;

/*
 * occupantDisplay - display a set of occupants.
 */

proc occupantDisplay(*OCCUPANTTYPE oc)void:
    ushort i;

    for i from 0 upto OCCUPANTCOUNT - 1 do
	putString("\n\tOccupant \#");
	putInt(i + 1);
	putString(": monster type \#");
	putInt(oc*.oc_type);
	putString(", probability ");
	putInt(oc*.oc_probability);
	putString(", ");
	printName(Monster[oc*.oc_type].m_name);
	oc := oc + sizeof(OCCUPANTTYPE);
    od;
    newLine();
corp;

/*
 * terPr - print the info for the given territory.
 */

proc terPr(TERRITORY t)void:
    *TERRITORYTYPE tp;

    tp := &Territory[t];
    putString("\nTerritory \#");
    putInt(t);
    putString(":\n\n\tDisplay pattern: \#");
    putInt(tp*.t_pattern);
    occupantDisplay(&tp*.t_occupants[0]);
    newLine();
corp;

/*
 * terDis - display the properties of a territory type.
 */

proc terDis()void:
    int n;

    if TerritoryNext = 0 then
	noTer();
    elif getNumber(&n,"Display which territory? ",0,TerritoryNext-1,true)then
	terPr(n);
    fi;
corp;

/*
 * terScn1 - scan the uses of this territory. Return 'true' if it's used.
 */

proc terScn1(TERRITORY t)bool:
    ushort i;
    bool used;

    used := false;
    for i from 0 upto range(TERRAIN) - 1 do
	if scan("Territory", "grid",
		pretend(&Grid[0].g_territorys[i], *ushort),
		t, GridNext, sizeof(GRIDTYPE)) ~= 0 then
	    used := true;
	fi;
    od;
    if scan("Territory", "special grid element",
	    pretend(&GridSpecial[0].gsp_territory, *ushort),
	    t, GridSpecialNext, sizeof(GRIDSPECIALTYPE)) ~= 0 then
	used := true;
    fi;
    used
corp;

/*
 * terDel - delete a selected territory.
 */

proc terDel()void:
    int n;
    TERRITORY t;
    ushort i;

    if TerritoryNext = 0 then
	noTer();
    elif getNumber(&n,"Delete which territory? ",0,TerritoryNext-1,true) then
	t := n;
	if not terScn1(t) then
	    for i from 0 upto range(TERRAIN) - 1 do
		decr(pretend(&Grid[0].g_territorys[i], *ushort),
		     t, GridNext, sizeof(GRIDTYPE));
	    od;
	    decr(pretend(&GridSpecial[0].gsp_territory, *ushort),
		 t, GridSpecialNext, sizeof(GRIDSPECIALTYPE));
	    TerritoryNext := TerritoryNext - 1;
	    while t ~= TerritoryNext do
		Territory[t] := Territory[t + 1];
		t := t + 1;
	    od;
	    putString("Territory deleted.\n");
	fi;
    fi;
corp;

/*
 * terScan - scan one or all territories for their usages.
 */

proc terScan()void:
    int n;
    TERRITORY t;

    if TerritoryNext = 0 then
	noTer();
    elif Number* ~= '\e' then
	if getNumber(&n,"Scan which territory? ",0,TerritoryNext-1,true) then
	    pretend(terScn1(n), void);
	fi;
    else
	t := 0;
	while t ~= TerritoryNext do
	    pretend(terScn1(t), void);
	    t := t + 1;
	od;
    fi;
corp;

/*
 * gspDis - display a grid special element.
 */

proc gspDis()void:
    int n;
    *GRIDSPECIALTYPE gsp;

    if GridSpecialNext = 0 then
	putString("This world has no grid special elements.\n");
    elif getNumber(&n, "Display which grid special? ",
		   0, GridSpecialNext - 1, true) then
	putString("\nGrid special \#");
	putInt(n);
	gsp := &GridSpecial[n];
	putString(":\n\n\tGrid: ");
	putInt(gsp*.gsp_grid);
	putString("\n\tLine: ");
	putInt(gsp*.gsp_line);
	putString("\n\tColumn: ");
	putInt(gsp*.gsp_col);
	putString("\n\tTerritory: ");
	putInt(gsp*.gsp_territory);
	putString("\n\n");
    fi;
corp;
