#/include/explore.g
#cre.g

extern
    getChar()char,
    putString(*char message)void,
    newLine()void,
    forceChar(char ch)void,
    installBlinker(proc()void blinker)void,
    installMouser(proc(uint yPos, xPos; bool lDown, rDown)void mouser)void,
    clear()void,
    line(ushort l1, c1, l2, c2; bool xor; ushort colour)void,
    pixel(ushort l, c, colour)void,
    rectangle(ushort l1, c1, l2, c2; bool xor; ushort colour)void,
    copyIn(ushort l, c, h, w; *uint p)void,
    copyInMasked(ushort l, c, h, w; *uint p, m)void,
    pointerOn()void,
    pointerOff()void,
    graphicsDown()void,
    button(char letter; ushort l, c)void,

    putInt(uint n)void,
    err(*char message)void,
    getNumber(*int pVal; *char prompt;
	      int minimumValue, maximumValue; bool inCom)bool,
    getNum(*char prompt; int minimumValue, maximumValue)int,
    getFileName(*char prompt, typ)bool,
    scan(*char n1, n2; *ushort p; ushort x, cnt, size)ushort,
    decr(*ushort p; ushort x, cnt, size)void,
    noPat()void,
    menuSelect(*uint pLastSelect; uint yPos, xPos)uint,
    setFullPalette(uint which)void,

    fileOpen(bool isRead)bool,
    fileOpen2()void,
    fileGet(*byte buffer; uint length)void,
    filePut(*byte buffer; uint length)void,
    fileClose()void;

ushort
    SCALE = 4,
    NOHIGHLIGHT = PATTERNCOLOURS;

uint
    DRAWTOP = 8,
    DRAWLEFT = 8,

    ROUNDLEFT = PATTERNCOLS * SCALE / 2 + DRAWLEFT,
    ROUNDTOP = PATTERNLINES * SCALE / 2 + DRAWTOP,
    TOPROUND = DRAWTOP / 2,
    RIGHTROUND = PATTERNCOLS * SCALE + DRAWLEFT + 4,
    BOTTOMROUND = PATTERNLINES * SCALE + DRAWTOP + 4,
    LEFTROUND = DRAWLEFT / 2,

    MAINTOP = 10,
    MAINBOTTOM = 46,
    MAINLEFT = 82,
    MAINRIGHT = 118;

type
    TEMPPATTERNTYPE = [PATTERNLINES, PATTERNCOLS] ushort;

PATTERN
    PatternCurrent;

*PATTERNTYPE
    PatternPtr;

TEMPPATTERNTYPE TempPattern;

ushort CurrentColour, HighLightColour;

uint LastSelect;

bool Edges, Force;

/*
 * sayPat - print the pattern editing prompt.
 */

proc sayPat()void:

    putString("PATTERN> ");
corp;

/*
 * patternError - issue an error message during pattern editing.
 */

proc patternError(*char message)void:

    err(message);
    sayPat();
corp;

/*
 * patBlink - blinker routine - we don't use blinking.
 */

proc patBlink()void:

corp;

/*
 * unpackPattern - unpack from the real PATTERNTYPE to the TEMPPATTERNTYPE.
 */

proc unpackPattern()void:
    PATTERNLINE l;
    PATTERNCOL c;
    uint i;
    ushort color;

    /* we cheat a bit since we know that a pattern is only 16 bits wide */
    for l from 0 upto PATTERNLINES - 1 do
	for c from 0 upto PATTERNCOLS - 1 do
	    color := 0;
	    for i from PATTERNDEPTH - 1 downto 0 do
		color := (color << 1) |
		    (PatternPtr*.pa_data[PATTERNDEPTH - 1 - i, l, 0] >>
			(PATTERNCOLS - 1 - c)) & 1;
	    od;
	    TempPattern[l, c] := color;
	od;
    od;
corp;

/*
 * packPattern - pack the pattern back into the PATTERNTYPE
 */

proc packPattern()void:
    PATTERNLINE l;
    PATTERNCOL c;
    uint i;
    uint bits;

    for i from 0 upto PATTERNDEPTH - 1 do
	for l from 0 upto PATTERNLINES - 1 do
	    bits := 0;
	    for c from 0 upto PATTERNCOLS - 1 do
		bits := (bits << 1) |
		    (TempPattern[l, c] >> (PATTERNDEPTH - 1 - i)) & 1;
	    od;
	    PatternPtr*.pa_data[i, l, 0] := bits;
	od;
    od;
corp;

/*
 * patternGadgets - display the pattern editing gadgets.
 */

proc patternGadgets()void:
    ushort C = DISPLAYCOLS * PATTERNCOLS + 1;
    ushort L = PATTERNLINES * 1 + 1;

    button(' ', 		   1, C);	/* I/O */
    line( 4, C +  3,  4, C +  5, false, 2);
    line( 4, C +  4,  7, C +  4, false, 2);
    line( 7, C +  3,  7, C +  5, false, 2);
    line( 4, C + 10, 11, C +  3, false, 2);
    line( 8, C +  8,  8, C + 10, false, 2);
    line( 8, C + 10, 11, C + 10, false, 2);
    line(11, C + 10, 11, C +  8, false, 2);
    line(11, C +  8,  8, C +  8, false, 2);
    button(' ', PATTERNLINES * 1 + 1, C);	/* F/S */
    line(L +  3, C +  5, L +  3, C +  3, false, 2);
    line(L +  3, C +  3, L +  7, C +  3, false, 2);
    line(L +  5, C +  3, L +  5, C +  5, false, 2);
    line(L +  3, C + 10, L + 10, C +  3, false, 2);
    line(L +  7, C + 10, L +  7, C +  8, false, 2);
    line(L +  7, C +  8, L +  9, C +  8, false, 2);
    line(L +  9, C +  8, L +  9, C + 10, false, 2);
    line(L +  9, C + 10, L + 11, C + 10, false, 2);
    line(L + 11, C + 10, L + 11, C +  8, false, 2);
    button('C', PATTERNLINES * 2 + 1, C);
    button('P', PATTERNLINES * 3 + 1, C);
    button('R', PATTERNLINES * 4 + 1, C);
    button('G', PATTERNLINES * 5 + 1, C);
    button('?', PATTERNLINES * 6 + 1, C);
    button('Q', PATTERNLINES * 7 + 1, C);
corp;

/*
 * horizRound - display a rounder gadget at the given line.
 */

proc horizRound(uint l; bool rounder)void:

    rectangle(l - 3, ROUNDLEFT - 8, l + 2, ROUNDLEFT + 7, false, 0);
    if rounder then
	line(l, ROUNDLEFT - 8, l - 3, ROUNDLEFT - 4, false, 1);
	line(l - 3, ROUNDLEFT - 4, l + 2, ROUNDLEFT + 4, false, 1);
	line(l + 2, ROUNDLEFT + 4, l, ROUNDLEFT + 7, false, 1);
    else
	line(l, ROUNDLEFT - 8, l, ROUNDLEFT + 7, false, 1);
    fi;
corp;

/*
 * vertRound - display a rounder gadget at the given column.
 */

proc vertRound(uint c; bool rounder)void:

    rectangle(ROUNDTOP - 8, c - 3, ROUNDTOP + 7, c + 2, false, 0);
    if rounder then
	line(ROUNDTOP - 8, c, ROUNDTOP - 4, c - 3, false, 1);
	line(ROUNDTOP - 4, c - 3, ROUNDTOP + 4, c + 2, false, 1);
	line(ROUNDTOP + 4, c + 2, ROUNDTOP + 7, c, false, 1);
    else
	line(ROUNDTOP - 8, c, ROUNDTOP + 7, c, false, 1);
    fi;
corp;

/*
 * patDisplayRounders - display the rounding control gadgets.
 */

proc patDisplayRounders()void:

    horizRound(TOPROUND, PatternPtr*.pa_topRound);
    vertRound(RIGHTROUND, PatternPtr*.pa_rightRound);
    horizRound(BOTTOMROUND, PatternPtr*.pa_bottomRound);
    vertRound(LEFTROUND, PatternPtr*.pa_leftRound);
corp;

/*
 * insertPattern - do full mode of displaying a pattern on the screen.
 *	This is includes all relevent rounding with neighbours. Passed in
 *	are the 8 neighbouring patterns.
 */

proc insertPattern(ushort row, col;
		  PATTERN tl, t, tr, l, me, r, bl, b, br)void:
    *PATTERNTYPE ptl, pt, ptr, pl, pme, pr, pbl, pb, pbr;

    ptl := &Pattern*[tl];
    pt := &Pattern*[t];
    ptr := &Pattern*[tr];
    pl := &Pattern*[l];
    pme := &Pattern*[me];
    pr := &Pattern*[r];
    pbl := &Pattern*[bl];
    pb := &Pattern*[b];
    pbr := &Pattern*[br];
    /* copy in the whole of the main pattern */
    copyIn(row, col, PATTERNLINES, PATTERNCOLS, &pme*.pa_data[0, 0, 0]);
    /* try to round my top edge */
    if (Force or t ~= me) and
	    pme*.pa_topRound and t ~= NOPATTERN and pt*.pa_bottomRound and
	    pt*.pa_topRound then
	copyInMasked(row, col, PATTERNLINES, PATTERNCOLS,
		     &pt*.pa_data[0, 0, 0], &Pattern*[0].pa_data[0, 0, 0]);
	if Edges and row ~= 0 and pme*.pa_bottomRound then
	    copyInMasked(row - PATTERNLINES, col, PATTERNLINES, PATTERNCOLS,
		    &pme*.pa_data[0, 0, 0], &Pattern*[2].pa_data[0, 0, 0]);
	fi;
    fi;
    /* try to round my right edge */
    if (Force or r ~= me) and
	    pme*.pa_rightRound and r ~= NOPATTERN and pr*.pa_leftRound and
	    pr*.pa_rightRound then
	copyInMasked(row, col, PATTERNLINES, PATTERNCOLS,
		     &pr*.pa_data[0, 0, 0], &Pattern*[1].pa_data[0, 0, 0]);
	if Edges and col ~= (DISPLAYCOLS - 1) * PATTERNCOLS and
		pme*.pa_leftRound then
	    copyInMasked(row, col + PATTERNCOLS, PATTERNLINES, PATTERNCOLS,
		     &pme*.pa_data[0, 0, 0], &Pattern*[3].pa_data[0, 0, 0]);
	fi;
    fi;
    /* try to round my bottom edge */
    if (Force or b ~= me) and
	    pme*.pa_bottomRound and b ~= NOPATTERN and pb*.pa_topRound and
	    pb*.pa_bottomRound then
	copyInMasked(row, col, PATTERNLINES, PATTERNCOLS,
		     &pb*.pa_data[0, 0, 0], &Pattern*[2].pa_data[0, 0, 0]);
	if Edges and row ~= (DISPLAYLINES - 1) * PATTERNLINES and
		pme*.pa_topRound then
	    copyInMasked(row + PATTERNLINES, col, PATTERNLINES, PATTERNCOLS,
		     &pme*.pa_data[0, 0, 0], &Pattern*[0].pa_data[0, 0, 0]);
	fi;
    fi;
    /* try to round my left edge */
    if (Force or l ~= me) and
	    pme*.pa_leftRound and l ~= NOPATTERN and pl*.pa_rightRound and
	    pl*.pa_leftRound then
	copyInMasked(row, col, PATTERNLINES, PATTERNCOLS,
		     &pl*.pa_data[0, 0, 0], &Pattern*[3].pa_data[0, 0, 0]);
	if Edges and col ~= 0 and pme*.pa_rightRound then
	    copyInMasked(row, col - PATTERNCOLS, PATTERNLINES, PATTERNCOLS,
		     &pme*.pa_data[0, 0, 0], &Pattern*[1].pa_data[0, 0, 0]);
	fi;
    fi;
    /* try to round my top-right corner */
    if (Force or tr ~= me) and tr ~= NOPATTERN and
	    pt*.pa_group = pr*.pa_group and ptr*.pa_group = pt*.pa_group and
	    pme*.pa_topRound and pme*.pa_rightRound and
	    pt*.pa_bottomRound and pr*.pa_leftRound and
	    ptr*.pa_topRound and ptr*.pa_rightRound then
	copyInMasked(row, col, PATTERNLINES, PATTERNCOLS,
		     &ptr*.pa_data[0, 0, 0], &Pattern*[4].pa_data[0, 0, 0]);
    fi;
    /* try to round my bottom-right corner */
    if (Force or br ~= me) and br ~= NOPATTERN and
	    pb*.pa_group = pr*.pa_group and pbr*.pa_group = pb*.pa_group and
	    pme*.pa_bottomRound and pme*.pa_rightRound and
	    pb*.pa_topRound and pr*.pa_leftRound and
	    pbr*.pa_bottomRound and pbr*.pa_rightRound then
	copyInMasked(row, col, PATTERNLINES, PATTERNCOLS,
		     &pbr*.pa_data[0, 0, 0], &Pattern*[5].pa_data[0, 0, 0]);
    fi;
    /* try to round my bottom-left corner */
    if (Force or bl ~= me) and bl ~= NOPATTERN and
	    pb*.pa_group = pl*.pa_group and pbl*.pa_group = pb*.pa_group and
	    pme*.pa_bottomRound and pme*.pa_leftRound and
	    pb*.pa_topRound and pl*.pa_rightRound and
	    pbl*.pa_bottomRound and pbl*.pa_leftRound then
	copyInMasked(row, col, PATTERNLINES, PATTERNCOLS,
		     &pbl*.pa_data[0, 0, 0], &Pattern*[6].pa_data[0, 0, 0]);
    fi;
    /* try to round my top-left corner */
    if (Force or tl ~= me) and tl ~= NOPATTERN and
	    pt*.pa_group = pl*.pa_group and ptl*.pa_group = pt*.pa_group and
	    pme*.pa_topRound and pme*.pa_leftRound and
	    pt*.pa_bottomRound and pl*.pa_rightRound and
	    ptl*.pa_topRound and ptl*.pa_leftRound then
	copyInMasked(row, col, PATTERNLINES, PATTERNCOLS,
		     &ptl*.pa_data[0, 0, 0], &Pattern*[7].pa_data[0, 0, 0]);
    fi;
corp;

/*
 * displayOneBackGround - display one background pattern.
 */

proc displayOneBackGround(uint i, j)void:

    insertPattern(
		(i + 5) * PATTERNLINES, j * PATTERNCOLS,
		if i = 0 or j = 0 then
		    NOPATTERN
		else
		    BackGroundPattern[i - 1, j - 1]
		fi,
		if i = 0 then
		    NOPATTERN
		else
		    BackGroundPattern[i - 1, j]
		fi,
		if i = 0 or j = 7 then
		    NOPATTERN
		else
		    BackGroundPattern[i - 1, j + 1]
		fi,
		if j = 0 then
		    NOPATTERN
		else
		    BackGroundPattern[i, j - 1]
		fi,
		BackGroundPattern[i, j],
		if j = 7 then
		    NOPATTERN
		else
		    BackGroundPattern[i, j + 1]
		fi,
		if i = 2 or j = 0 then
		    NOPATTERN
		else
		    BackGroundPattern[i + 1, j - 1]
		fi,
		if i = 2 then
		    NOPATTERN
		else
		    BackGroundPattern[i + 1, j]
		fi,
		if i = 2 or j = 7 then
		    NOPATTERN
		else
		    BackGroundPattern[i + 1, j + 1]
		fi
    );
corp;

/*
 * patDisplayBackGround - display the background patterns.
 */

proc patDisplayBackGround()void:
    uint i, j;

    for i from 0 upto 2 do
	for j from 0 upto 7 do
	    displayOneBackGround(i, j);
	od;
    od;
corp;

/*
 * patternDisplayScreen - display the screen for pattern editing.
 */

proc patternDisplayScreen()void:
    PATTERNLINE r;
    PATTERNCOL c;

    patDisplayBackGround();
    for r from 0 upto PATTERNLINES - 1 do
	for c from 0 upto PATTERNCOLS - 1 do
	    rectangle(r * SCALE + DRAWTOP, c * SCALE + DRAWLEFT,
		      (r + 1) * SCALE - 1 + DRAWTOP,
		      (c + 1) * SCALE - 1 + DRAWLEFT,
		      false, TempPattern[r, c]);
	od;
    od;
    patDisplayRounders();
corp;

/*
 * fillPattern - fill the selected pattern with the specified color.
 */

proc fillPattern(ushort color)void:
    uint i, j;
    PATTERNLINE r;
    PATTERNCOL c;

    for r from 0 upto PATTERNLINES - 1 do
	for c from 0 upto PATTERNCOLS - 1 do
	    TempPattern[r, c] := color;
	od;
    od;
    packPattern();
    rectangle(DRAWTOP, DRAWLEFT,
	      PATTERNLINES * SCALE - 1 + DRAWTOP,
	      PATTERNCOLS * SCALE - 1 + DRAWLEFT,
	      false, color);
    for i from 0 upto 2 do
	for j from 0 upto 7 do
	    if BackGroundPattern[i, j] = PatternCurrent then
		displayOneBackGround(i, j);
	    fi;
	od;
    od;
corp;

/*
 * setPoint - set the given point of the pattern to the given color.
 */

proc setPoint(PATTERNLINE r; PATTERNCOL c; ushort colour)void:
    uint i, j;
    SCREENLINE sr;
    SCREENCOL sc;

    TempPattern[r, c] := colour;
    rectangle(r * SCALE + DRAWTOP, c * SCALE + DRAWLEFT,
	      (r + 1) * SCALE - 1 + DRAWTOP, (c + 1) * SCALE - 1 + DRAWLEFT,
	      false, colour);
/* be nice to handled rounded pieces here! (but a pain!!) */
    for i from 0 upto 2 do
	for j from 0 upto 7 do
	    if BackGroundPattern[i, j] = PatternCurrent then
		pixel((i + 5) * PATTERNLINES + r, j * PATTERNCOLS + c, colour);
	    fi;
	od;
    od;
corp;

/*
 * patternRead - read the current pattern from a .pat file.
 */

proc patternRead()void:

    installBlinker(nil);
    pointerOff();
    if getFileName("File to read from? ", "pat") then
	if not fileOpen(true) then
	    patternError("Pattern file doesn't exist");
	else
	    fileGet(pretend(PatternPtr, *byte), sizeof(PATTERNTYPE));
	    fileClose();
	    unpackPattern();
	    patternDisplayScreen();
	    sayPat();
	fi;
    else
	putString("OK, no file read.\n");
	sayPat();
    fi;
    pointerOn();
    installBlinker(patBlink);
    forceChar('\e');
corp;

/*
 * patternWrite - write the current pattern to a .pat file.
 */

proc patternWrite()void:

    installBlinker(nil);
    pointerOff();
    if getFileName("File to write to? ", "pat") then
	packPattern();
	fileOpen2();
	filePut(pretend(PatternPtr, *byte), sizeof(PATTERNTYPE));
	fileClose();
    else
	putString("OK, no file written.\n");
    fi;
    pointerOn();
    installBlinker(patBlink);
    sayPat();
    forceChar('\e');
corp;

/*
 * patPalette - select a new palette.
 */

proc patPalette()void:

    installBlinker(nil);
    pointerOff();
    LastFullPalette := getNum("Full palette to use? ", 0, FullPaletteNext - 1);
    setFullPalette(LastFullPalette);
    pointerOn();
    installBlinker(patBlink);
    sayPat();
    forceChar('\e');
corp;

/*
 * patRotate - rotate the pattern 90 degrees counter-clockwise.
 */

proc patRotate()void:
    TEMPPATTERNTYPE tempPat;
    uint i, j;

    tempPat := TempPattern;
    for i from 0 upto PATTERNLINES - 1 do
	for j from 0 upto PATTERNCOLS - 1 do
	    TempPattern[i, j] := tempPat[j, PATTERNCOLS - 1 - i];
	od;
    od;
    packPattern();
    patternDisplayScreen();
corp;

/*
 * patFlip - flip a pattern about the vertical axis.
 */

proc patFlip()void:
    TEMPPATTERNTYPE tempPat;
    uint i, j;

    tempPat := TempPattern;
    for i from 0 upto PATTERNLINES - 1 do
	for j from 0 upto PATTERNCOLS - 1 do
	    TempPattern[i, j] := tempPat[i, PATTERNCOLS - 1 - j];
	od;
    od;
    packPattern();
    patternDisplayScreen();
corp;

/*
 * patSetGroup - set the rounding group for this pattern.
 */

proc patSetGroup()void:

    installBlinker(nil);
    pointerOff();
    PatternPtr*.pa_group :=
	getNum("Rounding group for this pattern? ", 0, 255);
    pointerOn();
    installBlinker(patBlink);
    sayPat();
    forceChar('\e');
corp;

/*
 * colourBox - XOR draw a box on the given colour's menu box.
 */

proc colourBox(ushort colour)void:
    uint xPos, yPos;

    xPos := 160 - 16 + colour / 16 * 8;
    yPos := colour % 16 * 8;
    rectangle(yPos, xPos, yPos + 7, xPos + 7, true, PATTERNCOLOURS - 1);
corp;

/*
 * unHighLight - remove any highlight of a colour menu box.
 */

proc unHighLight()void:

    if HighLightColour ~= NOHIGHLIGHT then
	colourBox(HighLightColour);
	HighLightColour := NOHIGHLIGHT;
    fi;
corp;

/*
 * patMainBox - draw the current colour box.
 */

proc patMainBox()void:

    rectangle(MAINTOP, MAINLEFT, MAINBOTTOM, MAINRIGHT, false, CurrentColour);
corp;

/*
 * patternHelp - display help info for pattern editing.
 */

proc patternHelp()void:

    putString("\nEditing pattern \#");
    putInt(PatternCurrent);
    putString(", group \#");
    putInt(PatternPtr*.pa_group);
    putString(
	"\nCommands are:\n"
	"  q - exit pattern editing         ? - this info\n"
	"  i - input pattern from file      o - output pattern to file\n"
	"  f - flip horizontally            s - rotate counterclockwise\n"
	"  c - clear to current colour      p - select new palette\n"
	"  r - redraw background patterns   g - set rounding group\n"
    );
    sayPat();
corp;

/*
 * patMouse - handle mouse events for pattern editing.
 */

proc patMouse(uint yPos, xPos; bool leftDown, rightDown)void:
    *PATTERN p;
    uint r, c;
    ushort newColour;

    if leftDown then
	if xPos >= 160 - 16 then
	    /* Cursor is over the colour menu */
	    LastSelect := 0;
	    newColour := (xPos - (160 - 16)) / 8 * 16 + yPos / 8;
	    if newColour ~= HighLightColour then
		unHighLight();
		HighLightColour := newColour;
		CurrentColour := newColour;
		colourBox(newColour);
		patMainBox();
	    fi;
	elif xPos >= DRAWLEFT and xPos < PATTERNCOLS * SCALE + DRAWLEFT and
		yPos >= DRAWTOP and yPos < PATTERNLINES * SCALE + DRAWTOP then
	    /* Cursor is over the drawing region */
	    LastSelect := 0;
	    unHighLight();
	    setPoint((yPos - DRAWTOP) / SCALE,
		     (xPos - DRAWLEFT)/ SCALE, CurrentColour);
	elif yPos >= PATTERNLINES * 5 and xPos < PATTERNCOLS * 8 then
	    /* Cursor is over the background patterns */
	    packPattern();
	    r := yPos / PATTERNLINES;
	    c := xPos / PATTERNCOLS;
	    p := &BackGroundPattern[r - 5, c];
	    p* :=
		if p* = PatternNext - 1 then
		    8
		else
		    p* + 1
		fi;
	    Force := true;
	    displayOneBackGround(r - 5, c);
	    Force := false;
	elif xPos >= ROUNDLEFT - 8 and xPos < ROUNDLEFT + 8 then
	    if yPos >= TOPROUND - 3 and yPos < TOPROUND + 3 then
		PatternPtr*.pa_topRound := not PatternPtr*.pa_topRound;
		horizRound(TOPROUND, PatternPtr*.pa_topRound);
	    elif yPos >= BOTTOMROUND - 3 and yPos < BOTTOMROUND + 3 then
		PatternPtr*.pa_bottomRound := not PatternPtr*.pa_bottomRound;
		horizRound(BOTTOMROUND, PatternPtr*.pa_bottomRound);
	    fi;
	elif xPos < RIGHTROUND + 3 and
		yPos >= ROUNDTOP - 8 and yPos < ROUNDTOP + 8 then
	    if xPos >= LEFTROUND - 3 and xPos < LEFTROUND + 3 then
		PatternPtr*.pa_leftRound := not PatternPtr*.pa_leftRound;
		vertRound(LEFTROUND, PatternPtr*.pa_leftRound);
	    elif xPos >= RIGHTROUND - 3 and xPos < RIGHTROUND + 3 then
		PatternPtr*.pa_rightRound := not PatternPtr*.pa_rightRound;
		vertRound(RIGHTROUND, PatternPtr*.pa_rightRound);
	    fi;
	else
	    unHighLight();
	    case menuSelect(&LastSelect, yPos, xPos)
	    incase 1:
		patternRead();
	    incase 2:
		patFlip();
	    incase 3:
		fillPattern(CurrentColour);
	    incase 4:
		patPalette();
	    incase 5:
		packPattern();
		patDisplayBackGround();
	    incase 6:
		patSetGroup();
	    incase 7:
		patternHelp();
		forceChar('\e');
	    incase 8:
		forceChar('q');
	    esac;
	fi;
    elif rightDown then
	unHighLight();
	if yPos >= PATTERNLINES * 5 and xPos < PATTERNCOLS * 8 then
	    /* Cursor is over the background patterns */
	    LastSelect := 0;
	    packPattern();
	    r := yPos / PATTERNLINES;
	    c := xPos / PATTERNCOLS;
	    p := &BackGroundPattern[r - 5, c];
	    p* :=
		if p* = 8 then
		    PatternNext - 1
		else
		    p* - 1
		fi;
	    Force := true;
	    displayOneBackGround(r - 5, c);
	    Force := false;
	else
	    case menuSelect(&LastSelect, yPos, xPos)
	    incase 1:
		patternWrite();
	    incase 2:
		patRotate();
	    esac;
	fi;
    else
	unHighLight();
	LastSelect := 0;
    fi;
corp;

/*
 * patternCommands - get and execute commands during pattern editing.
 */

proc patternCommands()void:
    char CONTROL_C = '\(0x03)';
    uint i, j;
    char ch;

    Edges := true;
    Force := false;
    installBlinker(patBlink);
    setFullPalette(LastFullPalette);
    for i from 0 upto 15 do
	rectangle(i * 8, 160 - 16, i * 8 + 7, 160 - 16 + 7, false, i);
	rectangle(i * 8, 160 -	8, i * 8 + 7, 160 -  8 + 7, false, i + 16);
    od;
    patternGadgets();
    CurrentColour := 2;
    line(MAINTOP - 1, MAINLEFT - 1, MAINTOP - 1, MAINRIGHT + 1, false, 1);
    line(MAINTOP, MAINRIGHT + 1, MAINBOTTOM + 1, MAINRIGHT + 1, false, 1);
    line(MAINBOTTOM + 1, MAINRIGHT, MAINBOTTOM + 1, MAINLEFT - 1, false, 1);
    line(MAINBOTTOM, MAINLEFT - 1, MAINTOP, MAINLEFT - 1, false, 1);
    patMainBox();
    HighLightColour := NOHIGHLIGHT;
    LastSelect := 0;
    installMouser(patMouse);
    pointerOn();
    graphicsDown();
    sayPat();
    while
	ch := getChar();
	ch ~= 'q' and ch ~= 'Q' and ch ~= CONTROL_C
    do
	case ch
	incase '\r':
	incase '\n':
	    newLine();
	    sayPat();
	incase '?':
	incase '\(0xfe)':
	    patternHelp();
	incase 'c':
	incase 'C':
	    fillPattern(CurrentColour);
	incase 'i':
	incase 'I':
	    patternRead();
	incase 'o':
	incase 'O':
	    patternWrite();
	incase 'p':
	incase 'P':
	    patPalette();
	incase 'r':
	incase 'R':
	    packPattern();
	    patDisplayBackGround();
	incase 's':
	incase 'S':
	    patRotate();
	incase 'f':
	incase 'F':
	    patFlip();
	incase 'g':
	incase 'G':
	    patSetGroup();
	default:
	    putString("*** Invalid command.\n");
	    sayPat();
	esac;
    od;
    newLine();
    pointerOff();
    installMouser(nil);
    installBlinker(nil);
    packPattern();
corp;

/*
 * patternCreate - create a new pattern.
 */

proc patternCreate()void:

    if PatternNext = PATTERNMAX then
	err("Too many patterns");
    else
	PatternCurrent := PatternNext;
	PatternNext := PatternNext + 1;
	putString("You are creating pattern \#");
	putInt(PatternCurrent);
	putString(".\n");
	PatternPtr := &Pattern*[PatternCurrent];
	PatternPtr*.pa_topRound := false;
	PatternPtr*.pa_rightRound := false;
	PatternPtr*.pa_bottomRound := false;
	PatternPtr*.pa_leftRound := false;
	PatternPtr*.pa_group := 0;
	clear();
	fillPattern(3);
	patDisplayRounders();
	patDisplayBackGround();
	patternCommands();
    fi;
corp;

/*
 * patternEdit - edit an existing pattern.
 */

proc patternEdit()void:
    uint i, j;
    int n;

    if getNumber(&n, "Edit which pattern? ", 0, PatternNext - 1, true) then
	PatternCurrent := n;
	PatternPtr := &Pattern*[PatternCurrent];
	unpackPattern();
	if PatternCurrent < 8 then
	    for i from 0 upto 2 do
		for j from 0 upto 7 do
		    BackGroundPattern[i, j] := j;
		od;
	    od;
	fi;
	clear();
	patternDisplayScreen();
	patternCommands();
    fi;
corp;

/*
 * patScn1 - check to see if the given pattern is used. Return 'true' if is.
 */

proc patScn1(PATTERN p)bool:

    scan("Pattern", "monster",
	 pretend(&Monster[0].m_pattern, *ushort),
	 p, MonsterNext, sizeof(MONSTERTYPE)) |
    scan("Pattern", "territory",
	 pretend(&Territory[0].t_pattern, *ushort),
	 p, TerritoryNext, sizeof(TERRITORYTYPE)) ~= 0
corp;

/*
 * patternDelete - select and delete a pattern.
 */

proc patternDelete()void:
    int n;

    if PatternNext = 8 then
	err("No more patterns can be deleted");
    elif getNumber(&n, "Delete which pattern? ", 8,PatternNext - 1,true) then
	PatternCurrent := n;
	if not patScn1(PatternCurrent) then
	    decr(pretend(&Monster[0].m_pattern, *ushort), PatternCurrent,
		 MonsterNext, sizeof(MONSTERTYPE));
	    decr(pretend(&Territory[0].t_pattern, *ushort), PatternCurrent,
		 TerritoryNext, sizeof(TERRITORYTYPE));
	    PatternNext := PatternNext - 1;
	    while PatternCurrent ~= PatternNext do
		Pattern*[PatternCurrent] := Pattern*[PatternCurrent + 1];
		PatternCurrent := PatternCurrent + 1;
	    od;
	    putString("Pattern deleted.\n");
	fi;
    fi;
corp;

/*
 * patScan - scan all patterns to see where they are used.
 */

proc patScan()void:
    int n;
    PATTERN p;

    if PatternNext = 8 then
	noPat();
    elif Number* ~= '\e' then
	if getNumber(&n, "Scan which pattern? ", 8, PatternNext - 1, true) then
	    pretend(patScn1(n), void);
	fi;
    else
	p := 0;
	while p ~= PatternNext do
	    pretend(patScn1(p), void);
	    p := p + 1;
	od;
    fi;
corp;

/*
 * edgesOn - enable edge drawing.
 */

proc edgesOn()void:

    Edges := true;
corp;

/*
 * edgesOff - disable edge drawing.
 */

proc edgesOff()void:

    Edges := false;
corp;

/*
 * forceOn - enable forced corners.
 */

proc forceOn()void:

    Force := true;
corp;

/*
 * forceOff - disable forced corners.
 */

proc forceOff()void:

    Force := false;
corp;
