#/include/explore.g
#cre.g

extern
    getChar()char,
    putChar(char ch)void,
    putString(*char message)void,
    newLine()void,
    forceChar(char ch)void,
    installBlinker(proc()void blinker)void,
    installMouser(proc(uint yPos, xPos; bool lDown, rDown)void mouser)void,
    clear()void,
    pointerOn()void,
    pointerOff()void,
    line(ushort l1, c1, l2, c2; bool xor; ushort colour)void,
    rectangle(ushort l1, c1, l2, c2; bool xor; ushort colour)void,
    picParameters(ushort fgColour, bgColour, pattern)void,
    picMove(ushort l, c)void,
    picDraw(ushort l, c)void,
    picEnd()void,
    graphicsDown()void,
    button(char letter; ushort l, c)void,

    putInt(uint n)void,
    err(*char message)void,
    ask(*char question)bool,
    getNumber(*int pVal; *char prompt;
	      int minimumValue, maximumValue; bool inCom)bool,
    getNum(*char prompt; int minimumValue, maximumValue)int,
    getFileName(*char prompt, typ)bool,
    scan(*char n1, n2; *ushort p; ushort x, cnt, size)ushort,
    decr(*ushort p; ushort x, cnt, size)void,
    noPic()void,
    menuSelect(*uint pLastSelect; uint yPos, xPos)uint,
    setTopPalette(uint which)void,

    fileOpen(bool isRead)bool,
    fileOpen2()void,
    fileClose()void,
    fileGet(*byte buffer; uint length)void,
    filePut(*byte buffer; uint length)void;

ushort
    NOHIGHLIGHT = PICTURECOLOURS,
    PATTERN_COUNT = 12;

enum {
    m_normal,			/* normal, not drawing or editing */
    m_polygon,			/* adding a new polygon */
    m_editing,			/* normal when editing top polygon */
    m_inserting,		/* inserting vertexes */
    m_deleting, 		/* deleting vertexes */
    m_moving			/* moving vertexes */
} Mode;

bool
    AddedLine,			/* Mode = m_polygon, line added to polygon */
    DrawnLines, 		/* other modes, lines present on screen */
    CanUnDelete;		/* have a polygon we can undelete */

PICTURE
    PictureCurrent;

*PICTURETYPE
    PicturePtr;

*POLYGONTYPE
    PolygonPtr;

*VERTEXTYPE
    PrevVertex, ThisVertex, NextVertex;

ushort
    PrimaryColour, SecondaryColour, HighLightColour, CurrentPattern;

ushort
    StartLine, StartColumn, EndLine, EndColumn;

uint LastSelect;

/*
 * sayPic - print the picture editing prompt.
 */

proc sayPic()void:

    putString("PICTURE> ");
corp;

/*
 * picErr - issue an error message during picture editing.
 */

proc picErr(*char message)void:

    err(message);
    sayPic();
corp;

/*
 * picBlink - blinker routine - we don't use blinking.
 */

proc picBlink()void:

corp;

/*
 * gadgetClear - clear gadgets when switching button sets.
 */

proc gadgetClear()void:

    rectangle(0, DISPLAYCOLS * PATTERNCOLS,
	      PATTERNLINES * 8 - 1, DISPLAYCOLS * PATTERNCOLS + 15,
	      false, 0);
corp;

/*
 * pictureGadgets - display the picture editing gadgets.
 */

proc pictureGadgets()void:
    ushort C = DISPLAYCOLS * PATTERNCOLS + 1;
    ushort L = PATTERNLINES * 1 + 1;

    button(' ', 		   1, C);	/* I/O */
    line( 4, C +  3,  4, C +  5, false, 2);
    line( 4, C +  4,  7, C +  4, false, 2);
    line( 7, C +  3,  7, C +  5, false, 2);
    line( 4, C + 10, 11, C +  3, false, 2);
    line( 8, C +  8,  8, C + 10, false, 2);
    line( 8, C + 10, 11, C + 10, false, 2);
    line(11, C + 10, 11, C +  8, false, 2);
    line(11, C +  8,  8, C +  8, false, 2);
    button(' ', PATTERNLINES * 1 + 1, C);	/* >/< */
    line(L +  3, C +  3, L +  5, C +  5, false, 2);
    line(L +  5, C +  5, L +  7, C +  3, false, 2);
    line(L +  3, C + 10, L + 10, C +  3, false, 2);
    line(L +  6, C + 10, L +  8, C +  8, false, 2);
    line(L +  8, C +  8, L + 10, C + 10, false, 2);
    button('-', PATTERNLINES * 2 + 1, C);
    button('+', PATTERNLINES * 3 + 1, C);
    button('P', PATTERNLINES * 4 + 1, C);
    button('E', PATTERNLINES * 5 + 1, C);
    button('?', PATTERNLINES * 6 + 1, C);
    button('Q', PATTERNLINES * 7 + 1, C);
corp;

/*
 * polyGadgets - display the polygon editing gadgets.
 */

proc polyGadgets()void:
    ushort C = DISPLAYCOLS * PATTERNCOLS + 1;

    button('+', 		   1, C);
    button('-', PATTERNLINES * 1 + 1, C);
    button('M', PATTERNLINES * 2 + 1, C);
    button('?', PATTERNLINES * 3 + 1, C);
    button('Q', PATTERNLINES * 4 + 1, C);
corp;

/*
 * picPoly - display the given polygon.
 */

proc picPoly(*POLYGONTYPE pg)void:
    *VERTEXTYPE v;
    uint count;

    picParameters(pg*.pg_fgColour + 16, pg*.pg_bgColour + 16, pg*.pg_pattern);
    v := &Vertex[pg*.pg_start];
    picMove(v*.v_line, v*.v_column);
    for count from 2 upto pg*.pg_vertexCount do
	v := v + sizeof(VERTEXTYPE);
	picDraw(v*.v_line, v*.v_column);
    od;
    picEnd();
    picParameters(16, 16, 0);
corp;

/*
 * picForGround - display the polygons of the picture.
 */

proc picForGround()void:
    *POLYGONTYPE pg;
    uint i;

    pg := &Polygon[PicturePtr*.p_start];
    for i from 1 upto PicturePtr*.p_polyCount do
	picPoly(pg);
	pg := pg + sizeof(POLYGONTYPE);
    od;
corp;

/*
 * picBackGround - display the screen for picture editing.
 */

proc picBackGround()void:
    SCREENLINE topInc, bottomInc, topNow, topPrev, bottomNow, bottomPrev;
    SCREENCOL sideInc, leftNow, leftPrev, rightNow, rightPrev;
    uint i;

    rectangle(0, 0, PICTURELINES - 1, PICTURECOLS - 1, false, 1);
    topInc := PICTURELINES / 6;
    bottomInc := PICTURELINES / 3;
    sideInc := PICTURECOLS / 4;
    topPrev := 0;
    bottomPrev := PICTURELINES - 1;
    leftPrev := 0;
    rightPrev := PICTURECOLS - 1;
    for i from 1 upto MAXVIEW do
	topNow := topPrev + topInc;
	bottomNow := bottomPrev - bottomInc;
	leftNow := leftPrev + sideInc;
	rightNow := rightPrev - sideInc;
	topInc := topInc / 2;
	bottomInc := bottomInc / 2;
	sideInc := sideInc / 2;
	line(topPrev, leftPrev, topNow, leftNow, false, 4);
	line(topPrev, rightPrev, topNow, rightNow, false, 4);
	line(bottomPrev, leftPrev, bottomNow, leftNow, false, 4);
	line(bottomPrev, rightPrev, bottomNow, rightNow, false, 4);
	line(topNow, rightNow, bottomNow, rightNow, false, 4);
	line(bottomNow, leftNow, topNow, leftNow, false, 4);
	topPrev := topNow;
	bottomPrev := bottomNow;
	leftPrev := leftNow;
	rightPrev := rightNow;
    od;
corp;

/*
 * pictureRead - read the current picture from a .pic file.
 */

proc pictureRead()void:
    PICTURETYPE picTemp;
    POLYGONTYPE polyTemp;
    bool abort;

    installBlinker(nil);
    pointerOff();
    if getFileName("File to read from? ", "pic") then
	if not fileOpen(true) then
	    picErr("Picture file doesn't exist");
	else
	    CanUnDelete := false;
	    if PicturePtr*.p_polyCount ~= 0 and
		    ask("Delete existing polygons first? ") then
		while PicturePtr*.p_polyCount ~= 0 do
		    PicturePtr*.p_polyCount := PicturePtr*.p_polyCount - 1;
		    PolygonNext := PolygonNext - 1;
		    VertexNext :=
			VertexNext - Polygon[PolygonNext].pg_vertexCount;
		od;
		PicturePtr*.p_start := PolygonNext;
	    fi;
	    fileGet(pretend(&picTemp, *byte), sizeof(PICTURETYPE));
	    if PolygonNext + picTemp.p_polyCount > POLYGONMAX then
		err("Too many polygons");
		picTemp.p_polyCount := POLYGONMAX - PolygonNext;
	    fi;
	    abort := false;
	    while picTemp.p_polyCount ~= 0 and not abort do
		picTemp.p_polyCount := picTemp.p_polyCount - 1;
		fileGet(pretend(&polyTemp, *byte), sizeof(POLYGONTYPE));
		if VertexNext + polyTemp.pg_vertexCount > VERTEXMAX then
		    err("Too many vertexes");
		    abort := true;
		else
		    PicturePtr*.p_polyCount := PicturePtr*.p_polyCount + 1;
		    polyTemp.pg_start := VertexNext;
		    Polygon[PolygonNext] := polyTemp;
		    PolygonNext := PolygonNext + 1;
		    fileGet(pretend(&Vertex[VertexNext], *byte),
			    sizeof(VERTEXTYPE) *
				make(polyTemp.pg_vertexCount, uint));
		    VertexNext := VertexNext + polyTemp.pg_vertexCount;
		fi;
	    od;
	    fileClose();
	    picForGround();
	    sayPic();
	fi;
    else
	putString("OK, no file read.\n");
	sayPic();
    fi;
    pointerOn();
    installBlinker(picBlink);
    forceChar('\e');
corp;

/*
 * pictureWrite - write the current picture to a .pic file.
 */

proc pictureWrite()void:
    *POLYGONTYPE pg;
    uint i;

    installBlinker(nil);
    pointerOff();
    if getFileName("File to write to? ", "pic") then
	fileOpen2();
	filePut(pretend(&PicturePtr*, *byte), sizeof(PICTURETYPE));
	pg := &Polygon[PicturePtr*.p_start];
	for i from 1 upto PicturePtr*.p_polyCount do
	    filePut(pretend(pg, *byte), sizeof(POLYGONTYPE));
	    filePut(pretend(&Vertex[pg*.pg_start], *byte),
		    sizeof(VERTEXTYPE) * make(pg*.pg_vertexCount, uint));
	    pg := pg + sizeof(POLYGONTYPE);
	od;
	fileClose();
    else
	putString("OK, no file written.\n");
    fi;
    pointerOn();
    installBlinker(picBlink);
    sayPic();
    forceChar('\e');
corp;

/*
 * picDeletePolygon - delete the top polygon in the picture.
 */

proc picDeletePolygon()void:

    if PicturePtr*.p_polyCount = 0 then
	picErr("no polygon to delete");
	forceChar('\e');
    else
	PicturePtr*.p_polyCount := PicturePtr*.p_polyCount - 1;
	PolygonNext := PolygonNext - 1;
	VertexNext := Polygon[PolygonNext].pg_start;
	picBackGround();
	picForGround();
	CanUnDelete := true;
    fi;
corp;

/*
 * picUnDeletePolygon - undelete the previously deleted polygon.
 */

proc picUnDeletePolygon()void:

    if CanUnDelete then
	CanUnDelete := false;
	PicturePtr*.p_polyCount := PicturePtr*.p_polyCount + 1;
	VertexNext := Polygon[PolygonNext].pg_start +
		      Polygon[PolygonNext].pg_vertexCount;
	picPoly(&Polygon[PolygonNext]);
	PolygonNext := PolygonNext + 1;
    else
	picErr("can't undelete a polygon now");
	forceChar('\e');
    fi;
corp;

/*
 * picRotateDown - rotate the polygons downwards, bringing bottom one to top.
 */

proc picRotateDown()void:
    *POLYGONTYPE pg;
    *VERTEXTYPE v, botV;
    POLYGONTYPE topPoly, botPoly;
    VERTEXTYPE tempV;
    uint pCount, botCount, gapCount, cnt;

    pCount := PicturePtr*.p_polyCount;
    if pCount > 1 then
	topPoly := Polygon[PicturePtr*.p_start + pCount - 1];
	botPoly := Polygon[PicturePtr*.p_start];
	botCount := botPoly.pg_vertexCount;
	gapCount := topPoly.pg_start + topPoly.pg_vertexCount -
		    botPoly.pg_start - botCount;
	/* shuffle the vertexes down */
	botV := &Vertex[botPoly.pg_start + botCount - 1];
	while botCount ~= 0 do
	    botCount := botCount - 1;
	    cnt := gapCount;
	    v := botV;
	    tempV := v*;
	    while cnt ~= 0 do
		cnt := cnt - 1;
		v* := (v + sizeof(VERTEXTYPE))*;
		v := v + sizeof(VERTEXTYPE);
	    od;
	    v* := tempV;
	    botV := botV - sizeof(VERTEXTYPE);
	od;
	/* shuffle the polygons down */
	pg := &Polygon[PicturePtr*.p_start];
	cnt := pCount - 1;
	while cnt ~= 0 do
	    cnt := cnt - 1;
	    pg* := (pg + sizeof(POLYGONTYPE))*;
	    pg := pg + sizeof(POLYGONTYPE);
	od;
	/* redirect and insert the new top polygon */
	botPoly.pg_start := botPoly.pg_start + gapCount;
	pg* := botPoly;
	/* redirect the pg_start fields of the shuffled polygons */
	pg := &Polygon[PicturePtr*.p_start];
	cnt := pCount - 1;
	while cnt ~= 0 do
	    cnt := cnt - 1;
	    pg*.pg_start := pg*.pg_start - botPoly.pg_vertexCount;
	    pg := pg + sizeof(POLYGONTYPE);
	od;
	/* only need to redisplay the new top polygon */
	picPoly(&Polygon[PicturePtr*.p_start + pCount - 1]);
    fi;
corp;

/*
 * picRotateUp - rotate the polygons upwards, moving the top one to bottom.
 */

proc picRotateUp()void:
    *POLYGONTYPE pg;
    *VERTEXTYPE topV, v;
    POLYGONTYPE topPoly, botPoly;
    VERTEXTYPE tempV;
    uint pCount, topCount, gapCount, cnt;

    pCount := PicturePtr*.p_polyCount;
    if pCount > 1 then
	topPoly := Polygon[PicturePtr*.p_start + pCount - 1];
	topCount := topPoly.pg_vertexCount;
	botPoly := Polygon[PicturePtr*.p_start];
	gapCount := topPoly.pg_start - botPoly.pg_start;
	/* shuffle the vertexes up */
	topV := &Vertex[topPoly.pg_start];
	while topCount ~= 0 do
	    topCount := topCount - 1;
	    v := topV;
	    cnt := gapCount;
	    tempV := v*;
	    while cnt ~= 0 do
		cnt := cnt - 1;
		v* := (v - sizeof(VERTEXTYPE))*;
		v := v - sizeof(VERTEXTYPE);
	    od;
	    v* := tempV;
	    topV := topV + sizeof(VERTEXTYPE);
	od;
	/* redirect the polygons before shuffling them */
	pg := &Polygon[PicturePtr*.p_start];
	cnt := pCount - 1;
	while cnt ~= 0 do
	    cnt := cnt - 1;
	    pg*.pg_start := pg*.pg_start + topPoly.pg_vertexCount;
	    pg := pg + sizeof(POLYGONTYPE);
	od;
	/* shuffle the polygons up */
	pg := &Polygon[PicturePtr*.p_start + pCount - 1];
	cnt := pCount - 1;
	while cnt ~= 0 do
	    cnt := cnt - 1;
	    pg* := (pg - sizeof(POLYGONTYPE))*;
	    pg := pg - sizeof(POLYGONTYPE);
	od;
	/* redirect and insert the new bottom polygon */
	topPoly.pg_start := botPoly.pg_start;
	pg* := topPoly;
	/* have to redisplay the entire picture */
	picForGround();
    fi;
corp;

/*
 * picPalette - select a new palette.
 */

proc picPalette()void:

    installBlinker(nil);
    pointerOff();
    LastHalfPalette := getNum("Half palette to use? ", 0, HalfPaletteNext - 1);
    setTopPalette(LastHalfPalette);
    pointerOn();
    installBlinker(picBlink);
    sayPic();
    forceChar('\e');
corp;

/*
 * picHelp - print out instructions for picture editing.
 */

proc picHelp()void:
    *POLYGONTYPE pg;
    uint count, total;

    pg := &Polygon[PicturePtr*.p_start];
    total := 0;
    for count from 1 upto PicturePtr*.p_polyCount do
	total := total + pg*.pg_vertexCount;
	pg := pg + sizeof(POLYGONTYPE);
    od;
    putString("\nEditing picture \#");
    putInt(PictureCurrent);
    putString(" which has ");
    putInt(PicturePtr*.p_polyCount);
    putString(" polygons and ");
    putInt(total);
    putString(" vertexes\n");
    putString(
	"Commands are:\n"
	"  q - exit picture editing     ? - this info\n"
	"  i - input picture from file  o - output picture to file\n"
	"  - - delete top polygon       + - undelete last deleted polygon\n"
	"  < - rotate polygons down     > - rotate polygons up\n"
	"  e - edit top polygon         p - select new palette\n"
    );
    sayPic();
corp;

/*
 * picColourBox - XOR draw a box on the given colour's menu box.
 */

proc picColourBox(ushort colour)void:
    uint xPos, yPos;

    xPos := 160 - 16 + colour / 8 * 8;
    yPos := colour % 8 * 8;
    rectangle(yPos, xPos, yPos + 7, xPos + 7, true, PATTERNCOLOURS - 1);
corp;

/*
 * picUnHighLight - remove any highlight of a colour menu box.
 */

proc picUnHighLight()void:

    if HighLightColour ~= NOHIGHLIGHT then
	picColourBox(HighLightColour);
	HighLightColour := NOHIGHLIGHT;
    fi;
corp;

/*
 * picPrimaryBox - draw a colour box of the current primary colour.
 */

proc picPrimaryBox()void:

    rectangle(66, 146, 77, 157, false, PrimaryColour + 16);
corp;

/*
 * picSecondaryBox - draw a colour box of the current secondary colour.
 */

proc picSecondaryBox()void:

    rectangle(80, 146, 91, 157, false, SecondaryColour + 16);
corp;

/*
 * picPatternBox - draw a patterned rectangle using the current colours
 *	and pattern.
 */

proc picPatternBox()void:

    picParameters(PrimaryColour + 16, SecondaryColour + 16, CurrentPattern);
    picMove(94, 146);
    picDraw(94, 157);
    picDraw(105, 157);
    picDraw(105, 146);
    picEnd();
    picParameters(16, 16, 0);
corp;

/*
 * vertDist - return the distance between the given vertex and the given pos.
 */

proc vertDist(*VERTEXTYPE v; uint yPos, xPos)uint:
    uint dist;
    int d1;

    d1 := yPos - v*.v_line;
    dist := d1 * d1;
    d1 := xPos - v*.v_column;
    dist + d1 * d1
corp;

/*
 * nearestVertex - find and set up the vertex that is nearest to the current
 *	mouse position, along with its neighbours.
 */

proc nearestVertex(uint yPos, xPos)void:
    *VERTEXTYPE v;
    *POLYGONTYPE pg;
    uint minPos, i, startVertex, vCount, minDist, dist;

    pg := &Polygon[PicturePtr*.p_start + PicturePtr*.p_polyCount - 1];
    startVertex := pg*.pg_start;
    vCount := pg*.pg_vertexCount;
    minDist := 0xffff;
    v := &Vertex[startVertex];
    for i from 0 upto vCount - 1 do
	dist := vertDist(v, yPos, xPos);
	if dist < minDist then
	    minDist := dist;
	    minPos := i;
	fi;
	v := v + sizeof(VERTEXTYPE);
    od;
    ThisVertex := &Vertex[startVertex + minPos];
    PrevVertex := &Vertex[startVertex +
	if minPos = 0 then
	    vCount - 1
	else
	    minPos - 1
	fi];
    NextVertex := &Vertex[startVertex +
	if minPos = vCount - 1 then
	    0
	else
	    minPos + 1
	fi];
    EndLine := yPos;
    EndColumn := xPos;
corp;

/*
 * vertexMovingLines1 - just draw the lines for vertex move/insert.
 */

proc vertexMovingLines1()void:

    line(PrevVertex*.v_line, PrevVertex*.v_column,
	 EndLine, EndColumn, true, 31);
    line(EndLine, EndColumn,
	 NextVertex*.v_line, NextVertex*.v_column, true, 31);
corp;

/*
 * vertexMovingLines - display the lines during vertex moving.
 */

proc vertexMovingLines(uint yPos, xPos)void:

    if xPos < PICTURECOLS then
	if DrawnLines then
	    vertexMovingLines1();
	fi;
	nearestVertex(yPos, xPos);
	vertexMovingLines1();
	DrawnLines := true;
    fi;
corp;

/*
 * vertexInsertingLines - display the lines during inserting.
 */

proc vertexInsertingLines(uint yPos, xPos)void:

    if xPos < PICTURECOLS then
	if DrawnLines then
	    vertexMovingLines1();
	fi;
	nearestVertex(yPos, xPos);
	if vertDist(PrevVertex, yPos, xPos) <
		vertDist(NextVertex, yPos, xPos) then
	    NextVertex := ThisVertex;
	else
	    PrevVertex := ThisVertex;
	fi;
	vertexMovingLines1();
	DrawnLines := true;
    fi;
corp;

/*
 * vertexDeletingLines1 - just draw the line during vertex deleting.
 */

proc vertexDeletingLines1()void:

    line(PrevVertex*.v_line, PrevVertex*.v_column,
	 NextVertex*.v_line, NextVertex*.v_column, true, 31);
corp;

/*
 * vertexDeletingLines - display the line during vertex deleting.
 */

proc vertexDeletingLines(uint yPos, xPos)void:

    if xPos < PICTURECOLS then
	if DrawnLines then
	    vertexDeletingLines1();
	fi;
	nearestVertex(yPos, xPos);
	vertexDeletingLines1();
	DrawnLines := true;
    fi;
corp;

/*
 * vertHelp - help during polygon editing.
 */

proc vertHelp()void:
    *POLYGONTYPE pg;
    uint count, total;

    pg := &Polygon[PicturePtr*.p_start];
    total := 0;
    for count from 1 upto PicturePtr*.p_polyCount do
	total := total + pg*.pg_vertexCount;
	pg := pg + sizeof(POLYGONTYPE);
    od;
    putString("\nEditing top polygon which has ");
    putInt(PolygonPtr*.pg_vertexCount);
    putString(" vertexes\n");
    putString(
	"Commands are:\n"
	"  q - exit polygon editing     ? - this info\n"
	"  + - insert new vertex(es)    - - delete vertex(es)\n"
	"  m - move vertex(es)\n"
    );
    sayPic();
corp;

/*
 * vertInsertVertex - set up for vertex insertion mode.
 */

proc vertInsertVertex()void:

    Mode := m_inserting;
    DrawnLines := false;
    vertexMovingLines(0, PICTURECOLS);
corp;

/*
 * vertDeleteVertex - set up for vertex deletion mode.
 */

proc vertDeleteVertex()void:

    Mode := m_deleting;
    DrawnLines := false;
    vertexDeletingLines(0, PICTURECOLS);
corp;

/*
 * vertMoveVertex - set up for vertex moving mode.
 */

proc vertMoveVertex()void:

    Mode := m_moving;
    DrawnLines := false;
    vertexMovingLines(0, PICTURECOLS);
corp;

/*
 * picEdit - the user wants to edit the top polygon.
 */

proc picEdit()void:
    char CONTROL_C = '\(0x03)';
    char ch;

    if PicturePtr*.p_polyCount = 0 then
	picErr("no polygons in picture");
	forceChar('\e');
    else
	PolygonPtr :=
	    &Polygon[PicturePtr*.p_start + PicturePtr*.p_polyCount - 1];
	/* set colours and pattern indicators as they are in the polygon */
	PrimaryColour := PolygonPtr*.pg_fgColour;
	picPrimaryBox();
	SecondaryColour := PolygonPtr*.pg_bgColour;
	picSecondaryBox();
	CurrentPattern := PolygonPtr*.pg_pattern;
	picPatternBox();
	gadgetClear();
	polyGadgets();
	Mode := m_editing;
	while
	    ch := getChar();
	    ch ~= 'q' and ch ~= 'Q' and ch ~= CONTROL_C
	do
	    case ch
	    incase '\r':
	    incase '\n':
		newLine();
		sayPic();
	    incase '?':
	    incase '\(0xfe)':
		vertHelp();
	    incase '+':
		vertInsertVertex();
	    incase '-':
		vertDeleteVertex();
	    incase 'm':
	    incase 'M':
		vertMoveVertex();
	    default:
		picErr("Invalid command; ? for help");
	    esac;
	od;
	gadgetClear();
	pictureGadgets();
	Mode := m_normal;
    fi;
corp;

/*
 * splitVertex - split the current vertex into two vertexes.
 */

proc splitVertex(uint yPos, xPos)void:
    *VERTEXTYPE v, vEnd;

    if DrawnLines then
	DrawnLines := false;
	vertexMovingLines1();
    fi;
    if VertexNext = VERTEXMAX then
	picErr("Too many vertexes");
	forceChar('\e');
    else
	vEnd := &Vertex[VertexNext - 1];
	while vEnd ~= PrevVertex do
	    (vEnd + sizeof(VERTEXTYPE))* := vEnd*;
	    vEnd := vEnd - sizeof(VERTEXTYPE);
	od;
	v := PrevVertex + sizeof(VERTEXTYPE);
	v*.v_line := yPos;
	v*.v_column := xPos;
	VertexNext := VertexNext + 1;
	PolygonPtr*.pg_vertexCount := PolygonPtr*.pg_vertexCount + 1;
	picBackGround();
	picForGround();
    fi;
corp;

/*
 * deleteVertex - delete the current vertex.
 */

proc deleteVertex()void:
    *VERTEXTYPE v, vEnd;

    if DrawnLines then
	DrawnLines := false;
	vertexDeletingLines1();
    fi;
    vEnd := &Vertex[VertexNext - 1];
    v := ThisVertex;
    while v ~= vEnd do
	v* := (v + sizeof(VERTEXTYPE))*;
	v := v + sizeof(VERTEXTYPE);
    od;
    VertexNext := VertexNext - 1;
    PolygonPtr*.pg_vertexCount := PolygonPtr*.pg_vertexCount - 1;
    if PolygonPtr*.pg_vertexCount < 2 then
	picErr("polygon deleted");
	Mode := m_editing;
	forceChar('q');
	PicturePtr*.p_polyCount := PicturePtr*.p_polyCount - 1;
	VertexNext := VertexNext - 1;
	PolygonNext := PolygonNext - 1;
	CanUnDelete := false;
    fi;
    picBackGround();
    picForGround();
corp;

/*
 * picMouse - handle mouse events for picture editing.
 */

proc picMouse(uint yPos, xPos; bool leftDown, rightDown)void:
    ushort newColour;

    if xPos < 160 - 16 or yPos >= 64 then
	picUnHighLight();
    fi;
    if xPos < PICTURECOLS then
	case Mode
	incase m_polygon:
	    line(StartLine, StartColumn, EndLine, EndColumn, true, 31);
	    EndLine := yPos;
	    EndColumn := xPos;
	    line(StartLine, StartColumn, yPos, xPos, true, 31);
	incase m_inserting:
	    vertexInsertingLines(yPos, xPos);
	incase m_moving:
	    vertexMovingLines(yPos, xPos);
	incase m_deleting:
	    vertexDeletingLines(yPos, xPos);
	esac;
    fi;
    if leftDown then
	if xPos >= 160 - 16 then
	    LastSelect := 0;
	    if Mode = m_normal or Mode = m_editing then
		if yPos < 64 then
		    /* Cursor is over the colour menu */
		    newColour := (xPos - (160 - 16)) / 8 * 8 + yPos / 8;
		    if newColour ~= HighLightColour then
			picUnHighLight();
			HighLightColour := newColour;
			PrimaryColour := newColour;
			picColourBox(newColour);
			picPrimaryBox();
			picPatternBox();
			if Mode = m_editing then
			    PolygonPtr*.pg_fgColour := newColour;
			    picPoly(PolygonPtr);
			fi;
		    fi;
		else
		    if yPos >= 94 and yPos <= 105 then
			/* cursor is over the pattern box */
			CurrentPattern :=
			    if CurrentPattern = PATTERN_COUNT - 1 then
				0
			    else
				CurrentPattern + 1
			    fi;
			picPatternBox();
			if Mode = m_editing then
			    PolygonPtr*.pg_pattern := CurrentPattern;
			    picPoly(PolygonPtr);
			fi;
		    fi;
		fi;
	    fi;
	elif xPos < PICTURECOLS then
	    /* cursor is in drawing region */
	    LastSelect := 0;
	    case Mode
	    incase m_normal:
		/* starting a new polygon */
		if PolygonNext = POLYGONMAX then
		    picErr("too many polygons");
		    forceChar('\e');
		elif VertexNext = VERTEXMAX then
		    picErr("too many vertexes");
		    forceChar('\e');
		else
		    CanUnDelete := false;
		    PicturePtr*.p_polyCount := PicturePtr*.p_polyCount + 1;
		    PolygonPtr := &Polygon[PolygonNext];
		    PolygonNext := PolygonNext + 1;
		    PolygonPtr*.pg_start := VertexNext;
		    PolygonPtr*.pg_fgColour := PrimaryColour;
		    PolygonPtr*.pg_bgColour := SecondaryColour;
		    PolygonPtr*.pg_pattern := CurrentPattern;
		    PolygonPtr*.pg_vertexCount := 1;
		    Vertex[VertexNext].v_line := yPos;
		    Vertex[VertexNext].v_column := xPos;
		    VertexNext := VertexNext + 1;
		    line(yPos, xPos, yPos, xPos, true, 31);
		    Mode := m_polygon;
		    StartLine := yPos;
		    StartColumn := xPos;
		    EndLine := yPos;
		    EndColumn := xPos;
		fi;
	    incase m_polygon:
		if not AddedLine then
		    /* adding a vertex to current polygon */
		    if VertexNext = VERTEXMAX then
			picErr("too many vertexes");
			forceChar('\e');
		    else
			Vertex[VertexNext].v_line := yPos;
			Vertex[VertexNext].v_column := xPos;
			VertexNext := VertexNext + 1;
			PolygonPtr*.pg_vertexCount :=
			    PolygonPtr*.pg_vertexCount + 1;
			StartLine := yPos;
			StartColumn := xPos;
			EndLine := yPos;
			EndColumn := xPos;
			AddedLine := true;
		    fi;
		fi;
	    incase m_moving:
		/* move the current vertex to mouse position */
		if DrawnLines then
		    DrawnLines := false;
		    vertexMovingLines1();
		    ThisVertex*.v_line := yPos;
		    ThisVertex*.v_column := xPos;
		    picBackGround();
		    picForGround();
		fi;
	    incase m_inserting:
		/* split the current vertex into two vertexes */
		splitVertex(yPos, xPos);
	    incase m_deleting:
		/* delete the current vertex */
		deleteVertex();
	    esac;
	else
	    if Mode = m_normal then
		case menuSelect(&LastSelect, yPos, xPos)
		incase 1:
		    pictureRead();
		incase 2:
		    picRotateUp();
		incase 3:
		    picDeletePolygon();
		incase 4:
		    picUnDeletePolygon();
		incase 5:
		    picPalette();
		incase 6:
		    picEdit();
		incase 7:
		    picHelp();
		    forceChar('\e');
		incase 8:
		    forceChar('q');
		esac;
	    elif Mode = m_editing then
		case menuSelect(&LastSelect, yPos, xPos)
		incase 1:
		    vertInsertVertex();
		incase 2:
		    vertDeleteVertex();
		incase 3:
		    vertMoveVertex();
		incase 4:
		    vertHelp();
		    forceChar('\e');
		incase 5:
		    forceChar('q');
		esac;
	    fi;
	fi;
    elif rightDown then
	if xPos >= 160 - 16 then
	    LastSelect := 0;
	    if Mode = m_normal or Mode = m_editing then
		if yPos < 64 then
		    /* Cursor is over the colour menu */
		    newColour := (xPos - (160 - 16)) / 8 * 8 + yPos / 8;
		    if newColour ~= HighLightColour then
			picUnHighLight();
			HighLightColour := newColour;
			SecondaryColour := newColour;
			picColourBox(newColour);
			picSecondaryBox();
			picPatternBox();
			if Mode = m_editing then
			    PolygonPtr*.pg_bgColour := newColour;
			    picPoly(PolygonPtr);
			fi;
		    fi;
		else
		    if yPos >= 94 and yPos <= 105 then
			/* cursor is over the pattern box */
			CurrentPattern :=
			    if CurrentPattern = 0 then
				PATTERN_COUNT - 1
			    else
				CurrentPattern - 1
			    fi;
			picPatternBox();
			if Mode = m_editing then
			    PolygonPtr*.pg_pattern := CurrentPattern;
			    picPoly(PolygonPtr);
			fi;
		    fi;
		fi;
	    fi;
	elif xPos < PICTURECOLS then
	    /* cursor is in drawing region */
	    LastSelect := 0;
	    case Mode
	    incase m_polygon:
		/* end any current polygon */
		AddedLine := false;
		Mode := m_normal;
		line(StartLine, StartColumn, EndLine, EndColumn, true, 31);
		if PolygonPtr*.pg_vertexCount = 1 then
		    picErr("polygon cancelled");
		    forceChar('\e');
		    PicturePtr*.p_polyCount := PicturePtr*.p_polyCount - 1;
		    VertexNext := VertexNext - 1;
		    PolygonNext := PolygonNext - 1;
		else
		    picPoly(PolygonPtr);
		fi;
	    incase m_inserting:
	    incase m_moving:
		/* end vertex moving or inserting mode */
		Mode := m_editing;
		if DrawnLines then
		    vertexMovingLines1();
		fi;
	    incase m_deleting:
		/* end of vertex deleting mode */
		Mode := m_editing;
		if DrawnLines then
		    vertexDeletingLines1();
		fi;
	    esac;
	else
	    if Mode = m_normal then
		case menuSelect(&LastSelect, yPos, xPos)
		incase 1:
		    pictureWrite();
		incase 2:
		    picRotateDown();
		esac;
	    fi;
	fi;
    else
	/* no buttons pressed */
	LastSelect := 0;
	case Mode
	incase m_normal:
	incase m_editing:
	    picUnHighLight();
	incase m_polygon:
	    AddedLine := false;
	incase m_inserting:
	    vertexInsertingLines(yPos, xPos);
	incase m_moving:
	    vertexMovingLines(yPos, xPos);
	incase m_deleting:
	    vertexDeletingLines(yPos, xPos);
	esac;
    fi;
corp;

/*
 * pictureCommands - get and execute commands during picture editing.
 */

proc pictureCommands()void:
    char CONTROL_C = '\(0x03)';
    uint i;
    char ch;

    installBlinker(picBlink);
    clear();
    setTopPalette(LastHalfPalette);
    for i from 0 upto 7 do
	rectangle(i * 8, 160 - 16, i * 8 + 7, 160 - 16 + 7, false, i + 16);
	rectangle(i * 8, 160 -	8, i * 8 + 7, 160 -  8 + 7, false, i + 24);
    od;
    picBackGround();
    picForGround();
    pictureGadgets();
    PrimaryColour := 0;
    SecondaryColour := 1;
    CurrentPattern := 0;
    HighLightColour := NOHIGHLIGHT;
    LastSelect := 0;
    picPrimaryBox();
    picSecondaryBox();
    picPatternBox();
    Mode := m_normal;
    AddedLine := false;
    CanUnDelete := false;
    installMouser(picMouse);
    pointerOn();
    graphicsDown();
    sayPic();
    while
	ch := getChar();
	ch ~= 'q' and ch ~= 'Q' and ch ~= CONTROL_C
    do
	case ch
	incase '\r':
	incase '\n':
	    newLine();
	    sayPic();
	incase '?':
	incase '\(0xfe)':
	    picHelp();
	incase 'i':
	incase 'I':
	    pictureRead();
	incase 'o':
	incase 'O':
	    pictureWrite();
	incase '-':
	    picDeletePolygon();
	incase '+':
	    picUnDeletePolygon();
	incase '<':
	    picRotateDown();
	incase '>':
	    picRotateUp();
	incase 'p':
	incase 'P':
	    picPalette();
	incase 'e':
	incase 'E':
	    picEdit();
	default:
	    picErr("Invalid command; ? for help");
	esac;
    od;
    newLine();
    pointerOff();
    installMouser(nil);
    installBlinker(nil);
corp;

/*
 * pictureCreate - create a new picture.
 */

proc pictureCreate()void:

    if PictureNext = PICTUREMAX then
	err("Too many pictures");
    else
	PictureCurrent := PictureNext;
	PictureNext := PictureNext + 1;
	putString("You are creating picture \#");
	putInt(PictureCurrent);
	putString(".\n");
	PicturePtr := &Picture[PictureCurrent];
	PicturePtr*.p_polyCount := 0;
	PicturePtr*.p_start := PolygonNext;
	pictureCommands();
    fi;
corp;

/*
 * pictureSelect - select a picture and make it the current one.
 */

proc pictureSelect(*char prompt; *uint pVCount)bool:
    *POLYGONTYPE pg, pgEnd;
    *VERTEXTYPE v, vEnd;
    int n;
    POLYGONTYPE pgTemp;
    VERTEXTYPE vTemp;
    POLYGON pgStart;
    VERTEX vStart;
    PICTURE pNum;
    POLYGON pgNum;
    uint pgCount, pgCnt, vCount, vCnt;

    if PictureNext = 0 then
	noPic();
	false
    elif getNumber(&n, prompt, 0, PictureNext - 1, true) then
	PictureCurrent := n;
	PicturePtr := &Picture[PictureCurrent];
	pgStart := PicturePtr*.p_start;
	pgCount := PicturePtr*.p_polyCount;
	pgCnt := pgCount;
	vStart := Polygon[pgStart].pg_start;
	vCount := 0;
	while pgCnt ~= 0 do
	    pgCnt := pgCnt - 1;
	    pg := &Polygon[pgCnt + pgStart];
	    pgTemp := pg*;
	    vCount := vCount + pgTemp.pg_vertexCount;
	    pgEnd := &Polygon[PolygonNext - pgCount + pgCnt];
	    while pg ~= pgEnd do
		pg* := (pg + sizeof(POLYGONTYPE))*;
		pg := pg + sizeof(POLYGONTYPE);
	    od;
	    pgEnd* := pgTemp;
	od;
	vCnt := vCount;
	while vCnt ~= 0 do
	    vCnt := vCnt - 1;
	    v := &Vertex[vCnt + vStart];
	    vTemp := v*;
	    vEnd := &Vertex[VertexNext - vCount + vCnt];
	    while v ~= vEnd do
		v* := (v + sizeof(VERTEXTYPE))*;
		v := v + sizeof(VERTEXTYPE);
	    od;
	    vEnd* := vTemp;
	od;
	for pNum from 0 upto PictureNext - 1 do
	    if Picture[pNum].p_start > pgStart then
		Picture[pNum].p_start := Picture[pNum].p_start - pgCount;
	    fi;
	od;
	if PolygonNext ~= 0 then
	    for pgNum from 0 upto PolygonNext - 1 do
		if Polygon[pgNum].pg_start >= vStart + vCount then
		    Polygon[pgNum].pg_start :=
			Polygon[pgNum].pg_start - vCount;
		elif Polygon[pgNum].pg_start >= vStart then
		    Polygon[pgNum].pg_start := Polygon[pgNum].pg_start +
			    (VertexNext - vCount - vStart);
		fi;
	    od;
	fi;
	PicturePtr*.p_start := PolygonNext - pgCount;
	pVCount* := vCount;
	true
    else
	false
    fi
corp;

/*
 * pictureEdit - edit an existing picture.
 */

proc pictureEdit()void:
    uint vCount;

    if pictureSelect("Edit which picture? ", &vCount) then
	pictureCommands();
    fi;
corp;

/*
 * picScn1 - check to see if the given picture is used.
 */

proc picScn1(PICTURE p)bool:

    scan("Picture", "monster",
	 pretend(&Monster[0].m_picture, *ushort),
	 p, MonsterNext, sizeof(MONSTERTYPE)) ~= 0
corp;

/*
 * pictureDelete - delete a picture.
 */

proc pictureDelete()void:
    uint vCount;

    if pictureSelect("Delete which picture? ", &vCount) then
	if not picScn1(PictureCurrent) then
	    decr(pretend(&Monster[0].m_picture, *ushort),
		 PictureCurrent, MonsterNext, sizeof(MONSTERTYPE));
	    PolygonNext := PolygonNext - PicturePtr*.p_polyCount;
	    VertexNext := VertexNext - vCount;
	    PictureNext := PictureNext - 1;
	    while PictureCurrent ~= PictureNext do
		Picture[PictureCurrent] := Picture[PictureCurrent + 1];
		PictureCurrent := PictureCurrent + 1;
	    od;
	    putString("Picture deleted.\n");
	fi;
    fi;
corp;

/*
 * pictureScan - scan all pictures to see where they are used.
 */

proc pictureScan()void:
    int n;
    PICTURE p;

    if PictureNext = 8 then
	noPic();
    elif Number* ~= '\e' then
	if getNumber(&n, "Scan which pattern? ", 0, PictureNext - 1, true) then
	    pretend(picScn1(n), void);
	fi;
    else
	p := 0;
	while p ~= PictureNext do
	    pretend(picScn1(p), void);
	    p := p + 1;
	od;
    fi;
corp;
