#/include/explore.g
#/include/user.g
#ex.g

extern
    beep()void,
    readChars(*char prompt, buffer; ushort length)void,
    print(*char mess)void,
    putString(*char mess)void,
    newLine()void;

/*
 * charsLen - return the length of the passed string.
 */

proc charsLen(*char p)uint:
    *char q;

    q := p;
    while q* ~= '\e' do
	q := q + 1;
    od;
    q - p
corp;

/*
 * cap - capitalize a character.
 */

proc cap(char ch)char:

    if ch >= 'a' and ch <= 'z' then
	ch - 32
    else
	ch
    fi
corp;

/*
 * readOb - get the number of an object from a list.
 */

proc readOb(*char prompt, noneMess;
		   *OBJECT obp; ushort skip, cnt)OBJECT:
    [80] char lineBuffer;
    *OBJECT op;
    *char p, q, r, prevName;
    ushort i, match;
    bool ambig;

    while
	readChars(prompt, &lineBuffer[0], 80);
	match := 255;
	if lineBuffer[0] = '\e' or cnt = 0 then
	    false
	else
	    op := obp;
	    ambig := false;
	    for i from 0 upto cnt - 1 do
		p := &lineBuffer[0];
		r := &Name[Object[op*].ob_name];
		q := r;
		while p* ~= '\e' and cap(p*) = cap(q*) do
		    p := p + 1;
		    q := q + 1;
		od;
		if p* = '\e' then
		    if match = 255 then
			match := op*;
			prevName := r;
		    else
			if r ~= prevName then
			    print("Ambiguous name.");
			    ambig := true;
			fi;
		    fi;
		fi;
		op := skip + op;
	    od;
	    if match = 255 then
		print(noneMess);
		true
	    else
		ambig
	    fi
	fi
    do
    od;
    match
corp;

/*
 * carry - attempt to carry an object.
 */

proc carry(OBJECT o)void:

    if V*.carryCount = V*.maxCarryCount then
	print("You can't carry any more things.");
    elif V*.carryWeight + Object[o].ob_weight > V*.maxCarryWeight then
	print("You can't carry any more weight.");
    else
	V*.carrying[V*.carryCount] := o;
	V*.carryCount := V*.carryCount + 1;
	V*.carryWeight := V*.carryWeight + Object[o].ob_weight;
    fi;
corp;

/*
 * fCarry - find carry slot for given object.
 */

proc fCarry(OBJECT o)ushort:
    ushort i;

    i := 0;
    while i ~= V*.carryCount and V*.carrying[i] ~= o do
	i := i + 1;
    od;
    i
corp;

/*
 * isCarrying - check to see if an object is being carried.
 */

proc isCarrying(OBJECT o)bool:

    fCarry(o) ~= V*.carryCount
corp;

/*
 * drop - drop an Object.
 */

proc drop(OBJECT o)void:
    ushort i;

    i := fCarry(o);
    if i ~= V*.carryCount then
	V*.carryCount := V*.carryCount - 1;
	V*.carryWeight := V*.carryWeight - Object[o].ob_weight;
	while i ~= V*.carryCount do
	    V*.carrying[i] := V*.carrying[i + 1];
	    i := i + 1;
	od;
	if V*.armed and not isCarrying(V*.weaponNumber) then
	    V*.armed := false;
	fi;
    fi;
corp;

/*
 * place - place an object at the specified location.
 */

proc place(OBJECT ob; bool onGr; ushort gridMaze, line, col)void:
    *DROPPED d;

    if V*.droppedCount ~= DROPPEDMAX then
	d := &V*.droppedList[V*.droppedCount];
	d*.d_onGrid := onGr;
	d*.d_gridMaze := gridMaze;
	d*.d_line := line;
	d*.d_col := col;
	d*.d_object := ob;
	V*.droppedCount := V*.droppedCount + 1;
    fi;
corp;

/*
 * placeHere - place the given object here.
 */

proc placeHere(OBJECT o)void:

    if V*.onGrid then
	place(o, true, V*.grid, V*.gridLine, V*.gridCol);
    else
	place(o, false, V*.maze, V*.mazeLine, V*.mazeCol);
    fi;
corp;

/*
 * hereCheck - check to see if the given dropped thing is here.
 */

proc hereCheck(*DROPPED d)bool:

    d*.d_onGrid = V*.onGrid and
	if V*.onGrid then
	    d*.d_gridMaze = V*.grid and
	    d*.d_line = V*.gridLine and d*.d_col = V*.gridCol
	else
	    d*.d_gridMaze = V*.maze and
	    d*.d_line = V*.mazeLine and d*.d_col = V*.mazeCol
	fi
corp;

/*
 * hereList - list all the things that are here.
 */

proc hereList()void:
    *DROPPED d;
    *char p;
    ushort i, pos;
    bool first;

    d := &V*.droppedList[0];
    i := V*.droppedCount;
    first := true;
    while i ~= 0 do
	i := i - 1;
	if hereCheck(d) then
	    pos :=
		if first then
		    first := false;
		    putString("Nearby: ");
		    9
		else
		    putString(", ");
		    pos + 2
		fi;
	    p := &Name[Object[d*.d_object].ob_name];
	    if charsLen(p) + pos + 2 > 80 then
		pos := 48;
		putString("\n    ");
	    fi;
	    putString(p);
	    pos := charsLen(p) + pos;
	fi;
	d := d + sizeof(DROPPED);
    od;
    if first then
	print("There is nothing nearby.");
    else
	newLine();
    fi;
corp;

/*
 * stuffCheck - check to see if there is stuff here.
 */

proc stuffCheck()void:
    *DROPPED d;
    ushort i;

    d := &V*.droppedList[0];
    i := V*.droppedCount;
    while i ~= 0 and not hereCheck(d) do
	i := i - 1;
	d := d + sizeof(DROPPED);
    od;
    if i ~= 0 then
	beep();
	hereList();
    fi;
corp;

/*
 * dropDel - delete the indicated entry from the 'droppedList' array.
 */

proc dropDel(*DROPPED d)void:

    V*.droppedCount := V*.droppedCount - 1;
    while d ~= &V*.droppedList[V*.droppedCount] do
	d* := (d + sizeof(DROPPED))*;
	d := d + sizeof(DROPPED);
    od;
corp;

/*
 * remove - take away the specified stored thing (if there is one).
 */

proc remove(OBJECT o; bool onGr; ushort grMa, line, col)void:
    *DROPPED d;
    ushort i;

    d := &V*.droppedList[0];
    i := V*.droppedCount;
    while i ~= 0 and
	    (d*.d_object ~= o or d*.d_onGrid ~= onGr or
	     d*.d_gridMaze ~= grMa or
	     d*.d_line ~= line or d*.d_col ~= col)
    do
	i := i - 1;
	d := d + sizeof(DROPPED);
    od;
    if i ~= 0 then
	dropDel(d);
    fi;
corp;

/*
 * pickUp - allow the user to pick something up.
 */

proc pickUp()void:
    *DROPPED d, end;
    ushort count, i;
    DROPPED temp;

    d := &V*.droppedList[0];
    end := d;
    count := 0;
    i := V*.droppedCount;
    while i ~= 0 do
	i := i - 1;
	if hereCheck(d) then
	    count := count + 1;
	    temp := d*;
	    d* := end*;
	    end* := temp;
	    end := end + sizeof(DROPPED);
	fi;
	d := d + sizeof(DROPPED);
    od;
    if count = 0 then
	print("There is nothing here to get.");
    else
	count := readOb("Get what? ", "There aren't any here.",
			&V*.droppedList[0].d_object, sizeof(DROPPED), count);
	if count = 255 then
	    print("OK - nothing picked up.");
	else
	    carry(count);
	    if isCarrying(count) then
		d := &V*.droppedList[0];
		while d*.d_object ~= count do
		    d := d + sizeof(DROPPED);
		od;
		dropDel(d);
		print("Taken.");
	    fi;
	fi;
    fi;
corp;

/*
 * isHere - return true if one of the specified objects is 'here'.
 */

proc isHere(OBJECT o)bool:
    *DROPPED d;
    ushort i;

    d := &V*.droppedList[0];
    i := V*.droppedCount;
    while i ~= 0 and (d*.d_object ~= o or not hereCheck(d)) do
	i := i - 1;
	d := d + sizeof(DROPPED);
    od;
    i ~= 0
corp;
